import {Component, Input} from '@angular/core';
import {EnvProperties} from '../../../utils/properties/env-properties';
import {ClaimDBContext, ClaimDBProject, ClaimDBResult} from "../claimHelper.class";

//Usage Example "<claim-entity [entity]="" [type]="" > </claim-entity>"

//externalUrl
@Component({
  selector: 'claim-entity',
  template: `
    <div *ngIf="type == 'publication'" title="Publication">
      <div class="uk-text-muted">publication</div>
      <!-- <span class="uk-margin-small-right uk-icon"><svg width="20" height="20" viewBox="0 0 20 20"
                                                        xmlns="http://www.w3.org/2000/svg" ratio="1"><rect fill="none"
                                                                                                           stroke="#000"
                                                                                                           x="3.5"
                                                                                                           y="2.5"
                                                                                                           width="12"
                                                                                                           height="16"></rect><polyline
         fill="none" stroke="#000" points="5 0.5 17.5 0.5 17.5 17"></polyline></svg></span>-->
      <publication-title [entity]="entity" param="id"
                         path="/search/result" [externalPortalUrl]=externalPortalUrl></publication-title>
    </div>
    <div *ngIf="type == 'dataset'" title="Dataset">
      <div class="uk-text-muted">research data</div>
      <!--<span class="uk-margin-small-right uk-icon"><svg width="20" height="20" viewBox="0 0 20 20"
                                                       xmlns="http://www.w3.org/2000/svg" ratio="1"><ellipse fill="none"
                                                                                                             stroke="#000"
                                                                                                             cx="10"
                                                                                                             cy="4.64"
                                                                                                             rx="7.5"
                                                                                                             ry="3.14"></ellipse><path
        fill="none" stroke="#000" d="M17.5,8.11 C17.5,9.85 14.14,11.25 10,11.25 C5.86,11.25 2.5,9.84 2.5,8.11"></path><path
        fill="none" stroke="#000"
        d="M17.5,11.25 C17.5,12.99 14.14,14.39 10,14.39 C5.86,14.39 2.5,12.98 2.5,11.25"></path><path fill="none"
                                                                                                      stroke="#000"
                                                                                                      d="M17.49,4.64 L17.5,14.36 C17.5,16.1 14.14,17.5 10,17.5 C5.86,17.5 2.5,16.09 2.5,14.36 L2.5,4.64"></path></svg></span>-->
      <publication-title [entity]="entity"  param="id"
                         path="/search/result"  [externalPortalUrl]=externalPortalUrl></publication-title>
    </div>
    <div *ngIf="type == 'software'" title="Software">
      <div class="uk-text-muted">software</div>
      <!-- <span class="uk-margin-small-right uk-icon">
         <svg width="20" height="20" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg" ratio="1"> <circle
           fill="none" stroke="#000" cx="9.997" cy="10" r="3.31"></circle> <path fill="none" stroke="#000"
                                                                                 d="M18.488,12.285 L16.205,16.237 C15.322,15.496 14.185,15.281 13.303,15.791 C12.428,16.289 12.047,17.373 12.246,18.5 L7.735,18.5 C7.938,17.374 7.553,16.299 6.684,15.791 C5.801,15.27 4.655,15.492 3.773,16.237 L1.5,12.285 C2.573,11.871 3.317,10.999 3.317,9.991 C3.305,8.98 2.573,8.121 1.5,7.716 L3.765,3.784 C4.645,4.516 5.794,4.738 6.687,4.232 C7.555,3.722 7.939,2.637 7.735,1.5 L12.263,1.5 C12.072,2.637 12.441,3.71 13.314,4.22 C14.206,4.73 15.343,4.516 16.225,3.794 L18.487,7.714 C17.404,8.117 16.661,8.988 16.67,10.009 C16.672,11.018 17.415,11.88 18.488,12.285 L18.488,12.285 Z"></path></svg>
       </span>-->
      <publication-title [entity]="entity"  param="id"
                         path="/search/result"  [externalPortalUrl]=externalPortalUrl></publication-title>
    </div>
    <div *ngIf="type == 'other'" title="Other reserch product">
      <div class="uk-text-muted">other</div>
      <!--<span class="uk-margin-small-right uk-icon">
        <svg width="20" height="20" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"> <polygon fill="none"
                                                                                                     stroke="#000"
                                                                                                     points="2.5,5.7 10,1.3 17.5,5.7 17.5,14.3 10,18.7 2.5,14.3"></polygon> <circle
          fill="none" stroke="#000" cx="10" cy="10" r="3.5"></circle></svg>
      </span>-->
      <publication-title [entity]="entity"  param="id"
                         path="/search/result"  [externalPortalUrl]=externalPortalUrl></publication-title>
    </div>
    <div *ngIf="type == 'project'  " title="Project">
      <div class="uk-text-muted">project</div>
      <!--<span class="uk-margin-small-right uk-icon"><svg width="20" height="20" viewBox="0 0 20 20"
                                                       xmlns="http://www.w3.org/2000/svg" ratio="1"><rect x="5" y="2"
                                                                                                          width="10"
                                                                                                          height="1"></rect><rect
        x="3" y="4" width="14" height="1"></rect><rect fill="none" stroke="#000" x="1.5" y="6.5" width="17"
                                                       height="11"></rect></svg></span>-->
      <project-title [project]="entity" [searchLink]=properties.searchLinkToProject
                     [externalPortalUrl]=externalPortalUrl></project-title>
    </div>
    <div *ngIf="type == 'context'  " title="Concept">
      <div class="uk-text-muted">community</div>
      <!--<span class="uk-margin-small-right uk-icon"><svg width="20" height="20" viewBox="0 0 20 20"
                                                       xmlns="http://www.w3.org/2000/svg" ratio="1"><circle fill="none"
                                                                                                            stroke="#000"
                                                                                                            stroke-width="1.1"
                                                                                                            cx="7.7"
                                                                                                            cy="8.6"
                                                                                                            r="3.5"></circle><path
        fill="none" stroke="#000" stroke-width="1.1"
        d="M1,18.1 C1.7,14.6 4.4,12.1 7.6,12.1 C10.9,12.1 13.7,14.8 14.3,18.3"></path><path fill="none" stroke="#000"
                                                                                            stroke-width="1.1"
                                                                                            d="M11.4,4 C12.8,2.4 15.4,2.8 16.3,4.7 C17.2,6.6 15.7,8.9 13.6,8.9 C16.5,8.9 18.8,11.3 19.2,14.1"></path></svg></span>-->
      <span>{{entity.title}}</span>
    </div>
  `
})

export class ClaimEntityFormatter {
  @Input() entity: ClaimDBResult | ClaimDBContext | ClaimDBProject;
  @Input() type: string;
  @Input() properties: EnvProperties;
  @Input() externalPortalUrl: string = null;

  constructor() {
  }

  ngOnInit() {
  }


}

