import { NgModule } from '@angular/core';

import { SharedModule } from '../../shared/shared.module';
import { ClaimsAdminComponent } from './claimsAdmin.component';
import {DisplayClaimsModule} from '../claim-utils/displayClaims/displayClaims.module';
import { AdminLoginGuard} from'../../login/adminLoginGuard.guard';
import {PreviousRouteRecorder} from '../../utils/piwik/previousRouteRecorder.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    SharedModule,
    DisplayClaimsModule

  ],
    providers:[AdminLoginGuard, PreviousRouteRecorder,IsRouteEnabled],
  declarations: [
    ClaimsAdminComponent
  ],
  exports:[ClaimsAdminComponent]
})
export class ClaimsAdminModule { }
