import { NgModule } from '@angular/core';

import { SharedModule } from '../../shared/shared.module';
import { DirectLinkingComponent } from './directLinking.component';

import {EntitySearchServiceModule} from '../../utils/entitiesAutoComplete/entitySearchService.module';
import {SearchResearchResultsServiceModule} from '../../services/searchResearchResultsService.module';
import {LoginGuard} from'../../login/loginGuard.guard';
import {PreviousRouteRecorder} from '../../utils/piwik/previousRouteRecorder.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';
import {LinkingGenericModule} from '../linking/linkingGeneric.module';

@NgModule({
  imports: [
    SharedModule,
    EntitySearchServiceModule, SearchResearchResultsServiceModule,
    Schema2jsonldModule, SEOServiceModule, LinkingGenericModule
  ],
  providers:[LoginGuard, PreviousRouteRecorder, IsRouteEnabled],
  declarations: [
    DirectLinkingComponent
  ], exports:[DirectLinkingComponent]
})
export class DirectLinkingModule { }
