import {Component, Input} from '@angular/core';
import {User} from "../../login/utils/helper.class";
import {UserManagementService} from "../../services/user-management.service";
import {LoginErrorCodes} from "../../login/utils/guardHelper.class";
import {Router} from "@angular/router";
import {Subscriber} from "rxjs";

@Component({
  selector: 'my-claims',
  template: `
    <div id="tm-main" class=" uk-section  uk-padding-remove-top tm-middle">
      <div class="uk-grid uk-margin-small-top" >
        <div class="tm-main uk-width-1-1@s uk-width-1-1@m  uk-width-1-1@l uk-row-first ">

          <div class="uk-container">
            <div class="uk-article-title custom-article-title">
              My links
            </div>

            <div class=" ">
              Manage your links in OpenAIRE
            </div>
            <div>
              <displayClaims *ngIf="user" [user]="user" [enableDelete]=true [myClaims]=true [isAdmin]=false [showUserEmail]=false
                              [claimsInfoURL]=claimsInfoURL [communityId]=communityId
                              [piwikSiteId]="piwikSiteId" title="My links">
              </displayClaims>
            </div>
          </div>
        </div>
      </div>
    </div>
  `

})
export class MyClaimsComponent {
  @Input() claimsInfoURL: string;
  @Input() communityId:string;
  @Input() piwikSiteId = null;
  @Input() userInfoURL: string;
  public user: User = null;

  constructor(private userManagementService: UserManagementService, private _router: Router) {}

  sub;
  ngOnDestroy() {
    if (this.sub instanceof Subscriber) {
      this.sub.unsubscribe();
    }
  }
  ngOnInit() {
    this.sub = this.userManagementService.getUserInfo().subscribe(user => {
      this.user = user;
      if (!user) {
        this._router.navigate(['/user-info'], {
          queryParams: {
            "errorCode": LoginErrorCodes.NOT_VALID,
            "redirectUrl": this._router.url
          }
        });
      }
    });
  }

}
