import { NgModule } from '@angular/core';

import { SharedModule } from '../../shared/shared.module';
import { MyClaimsComponent } from './myClaims.component';
import {DisplayClaimsModule} from '../claim-utils/displayClaims/displayClaims.module';
import {LoginGuard} from'../../login/loginGuard.guard';
import {PreviousRouteRecorder} from '../../utils/piwik/previousRouteRecorder.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    SharedModule,
    DisplayClaimsModule

  ],
  providers:[LoginGuard, PreviousRouteRecorder, IsRouteEnabled],
  declarations: [
    MyClaimsComponent
  ], exports: [MyClaimsComponent]
})
export class MyClaimsModule { }
