/* This module contains all common components for all landing pages */

import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule } from '@angular/router';

import {TabPagingComponent} from './tabPaging.component';
import {ShowTitleComponent} from './showTitle.component';
import {AddThisComponent} from './addThis.component';
import {PiwikServiceModule} from '../../utils/piwik/piwikService.module';
import {PreviousRouteRecorder} from'../../utils/piwik/previousRouteRecorder.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule, PiwikServiceModule
  ],
  declarations: [
      TabPagingComponent,  ShowTitleComponent, AddThisComponent
  ],
  providers:[
    PreviousRouteRecorder
   ],
  exports: [
     TabPagingComponent, ShowTitleComponent, AddThisComponent
    ]
})
export class LandingModule { }
