/* This module contains all common components for Publication & Daasets Landing Pages */
import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule } from '@angular/router';
import {PagingModule} from '../../utils/paging.module';
import {ShowIdentifiersComponent} from './showIdentifiers.component';
import {ShowSubjectsComponent} from './showSubjects.component';
import {FundedByComponent} from './fundedBy.component';
import {PublishedInComponent} from './publishedIn.component';
import {AvailableOnComponent} from './availableOn.component';
import {TabTableComponent} from './tabTable.component';
import {ShowPublisherComponent} from "./showPublisher.component";
import {ShowPublisherModule} from "./showPublisher.module";
import {RelatedToComponent} from "./relatedTo.component";


@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule, PagingModule, ShowPublisherModule
  ],
  declarations: [
    ShowIdentifiersComponent,ShowSubjectsComponent,
    FundedByComponent,PublishedInComponent,AvailableOnComponent,TabTableComponent,
    RelatedToComponent
  ],
  providers:[
  ],
  exports: [
    ShowIdentifiersComponent, ShowSubjectsComponent,
    FundedByComponent, PublishedInComponent, AvailableOnComponent, TabTableComponent, ShowPublisherComponent,
    RelatedToComponent
  ]
})
export class ResultLandingUtilsModule { }
