//import {MaterialModule} from '@angular/material';
import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';
import {FormsModule} from '@angular/forms';
import {RouterModule} from '@angular/router';
import {MatSelectModule} from "@angular/material";

import {ProjectComponent} from './project.component';
import {ProjectServiceModule} from './projectService.module';
import {HtmlProjectReportService} from "../htmlProjectReport/htmlProjectReport.service";
import {ReportsServiceModule} from '../../services/reportsService.module';
import {SearchResearchResultsServiceModule} from '../../services/searchResearchResultsService.module';

import {MetricsModule} from '../landing-utils/metrics/metrics.module';
import {LandingModule} from '../landing-utils/landing.module';
import {LandingHeaderModule} from "../landing-utils/landing-header/landing-header.module";

import {LoadingModalModule} from '../../utils/modal/loadingModal.module';
import {AlertModalModule} from '../../utils/modal/alertModal.module';
import {ErrorMessagesModule} from '../../utils/errorMessages.module';
import {HelperModule} from "../../utils/helper/helper.module";
import {IFrameModule} from '../../utils/iframe.module';

import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import {SEOServiceModule} from '../../sharedComponents/SEO/SEOService.module';
import {FeedbackModule} from "../feedback/feedback.module";
import {AltMetricsModule} from "../../utils/altmetrics.module";
import {TabsModule} from "../../utils/tabs/tabs.module";
import {SearchTabModule} from "../../utils/tabs/contents/search-tab.module";

@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule, LandingModule,
    LoadingModalModule, AlertModalModule, ErrorMessagesModule,
    IFrameModule, MetricsModule, ReportsServiceModule,
    SearchResearchResultsServiceModule, ProjectServiceModule,
    Schema2jsonldModule, SEOServiceModule, HelperModule,
    LandingHeaderModule, MatSelectModule, FeedbackModule, AltMetricsModule,
    TabsModule, SearchTabModule
  ],
  declarations: [
    ProjectComponent
  ],
  providers:[
     HtmlProjectReportService
  ],
  exports: [
    ProjectComponent
  ]
})
export class ProjectModule { }
