import {NgModule}                     from '@angular/core';
import {CommonModule}                 from '@angular/common';
import {FormsModule}                  from '@angular/forms';
import {RouterModule}                 from '@angular/router';

import {SharedModule}                 from '../../shared/shared.module';
import {MetricsModule}                from '../landing-utils/metrics/metrics.module';
import {LandingModule}                from '../landing-utils/landing.module';
import {CiteThisModule}               from '../landing-utils/citeThis/citeThis.module';
import {IFrameModule}                 from '../../utils/iframe.module';
import {AltMetricsModule}             from '../../utils/altmetrics.module';
import {PagingModule}                 from '../../utils/paging.module';

import {ResultLandingService}         from './resultLanding.service';
import {ResultLandingComponent}       from './resultLanding.component';
import {Schema2jsonldModule}          from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule }           from '../../sharedComponents/SEO/SEOService.module';

import {DeletedByInferenceModule}     from './deletedByInference/deletedByInference.module';
import {ShowAuthorsModule}            from "../../utils/authors/showAuthors.module";
import {HelperModule}                 from "../../utils/helper/helper.module";
import {ResultLandingUtilsModule}     from "../landing-utils/resultLandingUtils.module";
import {AlertModalModule}             from "../../utils/modal/alertModal.module";
import {AnnotationModule} from "../annotation/annotation.module";
import {LandingHeaderModule} from "../landing-utils/landing-header/landing-header.module";
import {NoLoadPaging} from "../../searchPages/searchUtils/no-load-paging.module";
import {ResultPreviewModule} from "../../utils/result-preview/result-preview.module";
import {FeedbackModule} from "../feedback/feedback.module";
import {TabsModule} from "../../utils/tabs/tabs.module";
import {LoadingModule} from "../../utils/loading/loading.module";
import {OrcidModule} from "../../orcid/orcid.module";

@NgModule({
  imports: [
    CommonModule, FormsModule, LandingModule, SharedModule, RouterModule,
    CiteThisModule, PagingModule, IFrameModule,
    MetricsModule, AltMetricsModule, Schema2jsonldModule, SEOServiceModule,
    DeletedByInferenceModule, ShowAuthorsModule, HelperModule, ResultLandingUtilsModule, AlertModalModule,
    AnnotationModule, LandingHeaderModule, NoLoadPaging, ResultPreviewModule, FeedbackModule, TabsModule, LoadingModule,
    OrcidModule
  ],
  declarations: [
    ResultLandingComponent
  ],
  providers: [
    ResultLandingService
  ],
  exports: [
    ResultLandingComponent
  ]
})
export class ResultLandingModule { }
