import { NgModule,  ModuleWithProviders }            from '@angular/core';
import { CommonModule }        from '@angular/common';

import {RouterModule} from "@angular/router";

import {OrcidComponent} from './orcid.component';
import {OrcidService} from "./orcid.service";
import {FreeGuard} from '../login/freeGuard.guard';
import {PreviousRouteRecorder} from "../utils/piwik/previousRouteRecorder.guard";
import {OrcidWorkComponent} from "./orcid-work.component";
import {AlertModalModule} from "../utils/modal/alertModal.module";
import {ResultLandingService} from "../landingPages/result/resultLanding.service";
import {LoadingModule} from "../utils/loading/loading.module";

@NgModule({
  imports: [
    CommonModule, RouterModule, AlertModalModule, LoadingModule
  ],
  declarations: [
    OrcidComponent,
    OrcidWorkComponent
  ],
  providers:[
    FreeGuard, PreviousRouteRecorder,
    OrcidService, ResultLandingService
  ],
  exports: [
    OrcidComponent,
    OrcidWorkComponent
  ]
})


export class OrcidModule{}
