import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule } from '@angular/router';

import{SearchPageTableViewComponent} from './searchPageTableView.component';
import{SearchFormModule} from './searchForm.module';
import{SearchResultsModule} from './searchResults.module';
import {SearchFilterModule} from './searchFilter.module';
import{LoadingModalModule} from '../../utils/modal/loadingModal.module';
import {ReportsServiceModule} from '../../services/reportsService.module';
import{SearchPagingModule} from './searchPaging.module';
import {SearchDownloadModule} from './searchDownload.module';
import {ModalModule} from '../../utils/modal/modal.module';
import {PagingModule} from '../../utils/paging.module';
import {SearchResultsPerPageModule} from './searchResultsPerPage.module';
import {DataTablesModule} from 'angular-datatables';

import {PiwikServiceModule} from '../../utils/piwik/piwikService.module';
import {PreviousRouteRecorder} from '../../utils/piwik/previousRouteRecorder.guard';

import {HelperModule} from '../../utils/helper/helper.module';
import {ErrorMessagesModule} from '../../utils/errorMessages.module';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';
import {AdvancedSearchFormModule} from "./advancedSearchForm.module";
import {EntitiesSelectionModule} from "./entitiesSelection.module";
import {BreadcrumbsModule} from "../../utils/breadcrumbs/breadcrumbs.module";


@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule, SearchFormModule, SearchResultsModule, LoadingModalModule,
    ReportsServiceModule, SearchPagingModule, SearchDownloadModule, ModalModule, PagingModule,
    DataTablesModule, SearchFilterModule, PiwikServiceModule, HelperModule, ErrorMessagesModule,
    Schema2jsonldModule, SEOServiceModule, SearchResultsPerPageModule, AdvancedSearchFormModule, EntitiesSelectionModule, BreadcrumbsModule
  ],
  declarations: [
    SearchPageTableViewComponent
],

  providers:[
    PreviousRouteRecorder
  ],
  exports: [
    SearchPageTableViewComponent
    ]
})
export class SearchPageTableViewModule { }
