import {Component, Input} from '@angular/core';
import {SearchResult}     from '../../utils/entities/searchResult';
import {ErrorCodes} from '../../utils/properties/errorCodes';
import {RouterHelper} from '../../utils/routerHelper.class';

@Component({
    selector: 'tab-result',
    templateUrl: 'tabResult.component.html'
  })

export class TabResultComponent {
    @Input() results: SearchResult[];
    @Input() status: number;
    @Input() type: string;
    @Input() urlParam: string;
    @Input() showLoading: boolean = false;
    @Input() showOrganizations: boolean = true;

    public errorCodes:ErrorCodes = new ErrorCodes();
    public routerHelper:RouterHelper = new RouterHelper();
    public errorMessage: string = "No results found";
    constructor () {

    }

    ngOnInit() {}

        public  quote(params: string):string {
            return '"'+params+'"';
        }
}
