import {Author, Organization, Project, ResultTitle} from "../result-preview/result-preview";

export class SearchResult {
  title: ResultTitle;
  id: string;
  DOIs: string[]=[];
  identifiers: Map<string, string[]>;

  //publications & datasets & orp & software & projects & dataproviders:
  description: string;

  //publications & datasets & orp & software & organizations:
  projects: Project[];
  
  //datasets & orp & publications & software
  year: string;
  embargoEndDate: Date | string;
  authors: Author[];
  countriesForResults: string[];
  languages: string[];
  
  //datasets & orp & software:
  publisher: string;
  
  //software
  programmingLanguages: string[];
  
  //dataproviders & projects:
  organizations: Organization[];
  
  //projects:
  acronym: string;
  code: string;
  // callIdentifier?: string; // currently not parsed
  funderShortname: string;
  budget?: string;
  contribution?: string;
  currency?: string;
  startYear: number;
  endYear: number;
  openAccessMandatePublications: boolean;
  openAccessMandateDatasets: boolean;
  
  //organizations:
  country: string;
  
  //dataproviders:
  englishname: string;
  type: string;
  websiteURL: string;
  OAIPMHURL: string;
  compatibility: string;
  compatibilityUNKNOWN: boolean;
  countries: string[];
  subjects: string[];
  
  entityType: string;
  types: string[];
  
  constructor() {
  }
  
}
