import {Component, ViewEncapsulation, ComponentRef, ElementRef, Input, EventEmitter, Output} from '@angular/core';

@Component({
  selector: 'modal-loading',
  template: `
  <!--uk-modal="center:true"-->
  <div [class]="(!isOpen)?'uk-modal ':'uk-modal uk-open uk-animation-fade'"   [open]="!isOpen"    tabindex="-1" role="dialog" >
    <div class="uk-modal-dialog" role="">
      <!--div class="modal-content"-->

        <div class="uk-modal-body">
          <div >
          <h4 class="text-center" >{{message}}</h4>
<!--          <div class="uk-spinner"></div>-->
            <div class="uk-animation-fade uk-margin-top  uk-width-1-1" role="alert">
              <span class="loading-gif  uk-align-center" ></span>
            </div>
            <ng-content></ng-content>

          </div>
        </div>

      </div>
    <!--/div-->
  </div>
  <!--div   class="uk-modal uk-open" aria-hidden="false" style="display: block; overflow-y: scroll;">
                            <div class="uk-modal-dialog" tabindex="">
                                <div class="uk-modal-spinner"></div>
                            </div>
                        </div-->
  `,
  encapsulation: ViewEncapsulation.None,
})
/**
  * API to an open alert window.
  */
export class ModalLoading{

@Input() public message:string ="Loading";

  /**
    * if the value is true alert will be visible or else it will be hidden.
    */
  public isOpen:boolean=false;
  /**
    * Emitted when a ok button was clicked
    * or when Ok method is called.
    */
  @Output() public alertOutput:EventEmitter<any> = new EventEmitter();
  constructor( public _elementRef: ElementRef){}
  /**
       * Opens a alert window creating backdrop.
       */
  open(){
    this.isOpen= true;
  }

  close(){
    this.isOpen = false;
  }
}
