export type Environment = "development" | "test" | "beta" | "production";
export type Dashboard = "explore" | "connect" | "monitor";
export type PortalType = "explore" | "connect" | "community" | "monitor" | "aggregator";

export interface EnvProperties {
  environment?: Environment;
  adminToolsPortalType?: PortalType;
  dashboard?: Dashboard;
  isDashboard?: boolean;
  domain?: string;
  enablePiwikTrack?: boolean;
  useCache?: boolean;
  useLongCache?: boolean;
  showAddThis?: boolean;
  showContent?: boolean;
  metricsAPIURL?: string;
  framesAPIURL?: string;
  statisticsFrameAPIURL?: string;
  statisticsFrameNewAPIURL?: string;
  useNewStatistisTool?: boolean;
  useOldStatisticsSchema?: boolean;
  monitorStatsFrameUrl?:string;
  disableFrameLoad?:boolean
  statisticsAPIURL?: string;
  impactFactorsAPIURL?: string;
  claimsAPIURL?: string;
  searchAPIURLLAst?: string;
  searchResourcesAPIURL?: string;
  openCitationsAPIURL?: string;
  csvAPIURL?: string;
  searchCrossrefAPIURL?: string;
  searchDataciteAPIURL?: string;
  searchOrcidURL?: string;
  orcidURL?: string;
  orcidAPIURL?: string;
  doiURL?: string;
  pmcURL?: string;
  pmidURL?: string;
  handleURL?: string;
  cordisURL?: string;
  openDoarURL?: string;
  r3DataURL?: string;
  sherpaURL?: string;
  sherpaURLSuffix?: string;
  zenodo?: string;
  zenodoCommunities?: string;
  openAccess?: string;
  openAccessRepo?: string;
  fp7Guidlines?: string;
  h2020Guidlines?: string;
  ercGuidlines?: string;
  helpdesk?: string;
  helpdeskEmail?: string;
  utilsService?: string;
  vocabulariesAPI?: string;
  piwikBaseUrl?: string;
  piwikSiteId?: string;
  loginUrl?: string;
  registryUrl?: string;
  logoutUrl?: string;
  userInfoUrl?: string;
  cookieDomain?: string;
  feedbackmail?: string;
  feedbackmailForMissingEntities?: string;
  cacheUrl?: string;
  deleteCacheUrl?: string;
  monitorServiceAPIURL?: string;
  adminToolsAPIURL?: string;
  adminToolsCommunity?: string;
  useHelpTexts?:boolean;
  contextsAPI?: string;
  communityAPI?: string;
  communitiesAPI?: string;
  datasourcesAPI?: string;
  miningBackendURL?: string;
  csvLimit?: number;
  pagingLimit?: number;
  resultsPerPage?: number;
  baseLink?: string;
  baseOpenaireLink?: string;
  afterLoginRedirectLink?: string;
  searchLinkToResult?: string;
  searchLinkToPublication?: string;
  searchLinkToProject?: string;
  searchLinkToDataProvider?: string;
  searchLinkToDataset?: string;
  searchLinkToSoftwareLanding?: string;
  searchLinkToOrp?: string;
  searchLinkToOrganization?: string;
  //Search pages
  searchLinkToCommunities?: string;
  searchLinkToStakeholders?: string;
  searchLinkToPublications?: string;
  searchLinkToDataProviders?: string;
  searchLinkToProjects?: string;
  searchLinkToDatasets?: string;
  searchLinkToSoftware?: string;
  searchLinkToOrps?: string;
  searchLinkToOrganizations?: string;
  searchLinkToCompatibleDataProviders?: string;
  searchLinkToEntityRegistriesDataProviders?: string;
  searchLinkToEntityRegistriesDataProvidersTable?: string;
  searchLinkToJournals?: string;
  searchLinkToJournalsTable?: string;
  searchLinkToResults?: string;
  //Advanced Search for pages
  searchLinkToAdvancedPublications?: string;
  searchLinkToAdvancedProjects?: string;
  searchLinkToAdvancedDatasets?: string;
  searchLinkToAdvancedSoftware?: string;
  searchLinkToAdvancedOrps?: string;
  searchLinkToAdvancedDataProviders?: string;
  searchLinkToAdvancedOrganizations?: string;
  searchLinkToAdvancedResults?: string;
  lastIndexInformationLink?: string;
  showLastIndexInformationLink?: boolean;
  widgetLink?: string;
  claimsInformationLink?: string;
  depositLearnHowPage?: string;
  depositSearchPage?: string;
  shareInZenodoPage?: string;
  // recaptcha site key
  reCaptchaSiteKey?: string;
  // contact us recipients
  admins?: string[];
  lastIndexUpdate?: string;
  indexInfoAPI?: string;
  altMetricsAPIURL?: string;
  b2noteAPIURL?: string;
  adminPortalURL?: string;
  sushiliteURL?: string;
}
