import { NgModule}      from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule }  from '@angular/forms';
import { RouterModule } from '@angular/router';

import {RangeFilterComponent} from './rangeFilter.component';
import {InValidYearValidatorDirective} from "./inValidYear.directive";
import {FromYearAfterToYearValidatorDirective} from "./fromYearAfterToYear.directive";
import {RangeYearsRequiredDirective} from "./rangeYearsRequired.directive";

@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule
  ],
  declarations: [
    RangeFilterComponent, InValidYearValidatorDirective, FromYearAfterToYearValidatorDirective, RangeYearsRequiredDirective
  ],
  providers:[
  ],
  exports: [
    RangeFilterComponent
  ]
})
export class RangeFilterModule { }
