export class Citation{
  public templates:string[]=["bibtex","chicago","ieee","science","apa","cell","harvard","mla","nature","acm","frontiers", "ama"];
  public fileFormats:string[]=["bibtex", "ris"];
  public fileSuffix:string[]=[".bib", ".ris"];
  //https://github.com/citation-style-language/styles
  bibtex:string =`<?xml version="1.0" encoding="UTF-8"?><style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only" default-locale="en-US"><info><title>BibTeX generic citation style</title><id>http://www.zotero.org/styles/bibtex</id><link href="http://www.zotero.org/styles/bibtex" rel="self" /><link href="http://www.bibtex.org/" rel="documentation" /><author><name>Markus Schaffner</name></author><contributor><name>Richard Karnesky</name><email>karnesky+zotero@gmail.com</email><uri>http://arc.nucapt.northwestern.edu/Richard_Karnesky</uri></contributor><category citation-format="author-date" /><category field="generic-base" /><updated>2012-09-14T21:22:32+00:00</updated><rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights></info><macro name="zotero2bibtexType"><choose><if type="bill book graphic legal_case legislation motion_picture report song" match="any"><text value="book" /></if><else-if type="chapter" match="any"><text value="inbook" /></else-if><else-if type="article article-journal article-magazine article-newspaper" match="any"><text value="article" /></else-if><else-if type="thesis" match="any"><text value="phdthesis" /></else-if><else-if type="manuscript" match="any"><text value="unpublished" /></else-if><else-if type="paper-conference" match="any"><text value="inproceedings" /></else-if><else-if type="report" match="any"><text value="techreport" /></else-if><else><text value="misc" /></else></choose></macro><macro name="citeKey"><group delimiter="_"><text macro="author-short" text-case="lowercase" /><text macro="issued-year" /></group></macro><macro name="author-short"><names variable="author"><name form="short" delimiter="_" delimiter-precedes-last="always" /><substitute><names variable="editor" /><names variable="translator" /><choose><if type="bill book graphic legal_case legislation motion_picture report song" match="any"><text variable="title" form="short" /></if><else><text variable="title" form="short" /></else></choose></substitute></names></macro><macro name="issued-year"><date variable="issued"><date-part name="year" /></date></macro><macro name="issued-month"><date variable="issued"><date-part name="month" form="short" strip-periods="true" /></date></macro><macro name="author"><names variable="author"><name sort-separator=", " delimiter=" and " delimiter-precedes-last="always" name-as-sort-order="all" /></names></macro><macro name="editor-translator"><names variable="editor translator" delimiter=", "><name sort-separator=", " delimiter=" and " delimiter-precedes-last="always" name-as-sort-order="all" /></names></macro><macro name="title"><text variable="title" /></macro><macro name="number"><text variable="issue" /><text variable="number" /></macro><macro name="container-title"><choose><if type="chapter paper-conference" match="any"><text variable="container-title" prefix=" booktitle={" suffix="}" /></if><else><text variable="container-title" prefix=" journal={" suffix="}" /></else></choose></macro><macro name="publisher"><choose><if type="thesis"><text variable="publisher" prefix=" school={" suffix="}" /></if><else-if type="report"><text variable="publisher" prefix=" institution={" suffix="}" /></else-if><else><text variable="publisher" prefix=" publisher={" suffix="}" /></else></choose></macro><macro name="pages"><text variable="page" /></macro><macro name="edition"><text variable="edition" /></macro><citation et-al-min="11" et-al-use-first="10" disambiguate-add-year-suffix="true" disambiguate-add-names="false" disambiguate-add-givenname="false" collapse="year"><sort><key macro="author" /><key variable="issued" /></sort><layout delimiter="_"><text macro="citeKey" /></layout></citation><bibliography hanging-indent="false" et-al-min="11" et-al-use-first="10"><sort><key macro="author" /><key variable="issued" /></sort><layout><text macro="zotero2bibtexType" prefix=" @" /><group prefix="{" suffix=" }" delimiter=", "><text macro="citeKey" /><text variable="publisher-place" prefix=" place={" suffix="}" /><!--Fix This--><text variable="chapter-number" prefix=" chapter={" suffix="}" /><!--Fix This--><text macro="edition" prefix=" edition={" suffix="}" /><!--Is this in CSL? <text variable="type" prefix=" type={" suffix="}"/>--><text variable="collection-title" prefix=" series={" suffix="}" /><text macro="title" prefix=" title={" suffix="}" /><text variable="volume" prefix=" volume={" suffix="}" /><!--Not in CSL<text variable="rights" prefix=" rights={" suffix="}"/>--><text variable="ISBN" prefix=" ISBN={" suffix="}" /><text variable="ISSN" prefix=" ISSN={" suffix="}" /><!--Not in CSL <text variable="LCCN" prefix=" callNumber={" suffix="}"/>--><text variable="archive_location" prefix=" archiveLocation={" suffix="}" /><text variable="URL" prefix=" url={" suffix="}" /><text variable="DOI" prefix=" DOI={" suffix="}" /><text variable="abstract" prefix=" abstractNote={" suffix="}" /><text variable="note" prefix=" note={" suffix="}" /><text macro="number" prefix=" number={" suffix="}" /><text macro="container-title" /><text macro="publisher" /><text macro="author" prefix=" author={" suffix="}" /><text macro="editor-translator" prefix=" editor={" suffix="}" /><text macro="issued-year" prefix=" year={" suffix="}" /><text macro="issued-month" prefix=" month={" suffix="}" /><text macro="pages" prefix=" pages={" suffix="}" /><text variable="collection-title" prefix=" collection={" suffix="}" /></group></layout></bibliography></style>`;
  ieee:string =`<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only"> <info> <title>IEEE</title> <id>http://www.zotero.org/styles/ieee</id> <link href="http://www.zotero.org/styles/ieee" rel="self"/> <link href="http://www.ieee.org/documents/style_manual.pdf" rel="documentation"/> <link href="http://www.ieee.org/documents/auinfo07.pdf" rel="documentation"/> <author> <name>Michael Berkowitz</name> <email>mberkowi@gmu.edu</email> </author> <contributor> <name>Julian Onions</name> <email>julian.onions@gmail.com</email> </contributor> <contributor> <name>Rintze Zelle</name> <uri>http://twitter.com/rintzezelle</uri> </contributor> <contributor> <name>Stephen Frank</name> <uri>http://www.zotero.org/sfrank</uri> </contributor> <contributor> <name>Sebastian Karcher</name> </contributor> <category citation-format="numeric"/> <category field="engineering"/> <category field="generic-base"/> <updated>2016-10-06T15:32:30+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <locale xml:lang="en"> <terms> <term name="chapter" form="short">ch.</term> <term name="presented at">presented at the</term> <term name="available at">available</term> </terms> </locale> <!-- Macros --> <macro name="edition"> <choose> <if type="bill book chapter graphic legal_case legislation motion_picture paper-conference report song" match="any"> <choose> <if is-numeric="edition"> <group delimiter=" "> <number variable="edition" form="ordinal"/> <text term="edition" form="short"/> </group> </if> <else> <text variable="edition" text-case="capitalize-first" suffix="."/> </else> </choose> </if> </choose> </macro> <macro name="issued"> <choose> <if type="article-journal report" match="any"> <date variable="issued"> <date-part name="month" form="short" suffix=" "/> <date-part name="year" form="long"/> </date> </if> <else-if type=" bill book chapter graphic legal_case legislation motion_picture paper-conference song thesis" match="any"> <date variable="issued"> <date-part name="year" form="long"/> </date> </else-if> <else> <date variable="issued"> <date-part name="day" form="numeric-leading-zeros" suffix="-"/> <date-part name="month" form="short" suffix="-" strip-periods="true"/> <date-part name="year" form="long"/> </date> </else> </choose> </macro> <macro name="author"> <names variable="author"> <name and="text" et-al-min="7" et-al-use-first="1" initialize-with=". "/> <label form="short" prefix=", " text-case="capitalize-first"/> <et-al font-style="italic"/> <substitute> <names variable="editor"/> <names variable="translator"/> </substitute> </names> </macro> <macro name="editor"> <names variable="editor"> <name initialize-with=". " delimiter=", " and="text"/> <label form="short" prefix=", " text-case="capitalize-first"/> </names> </macro> <macro name="locators"> <group delimiter=", "> <text macro="edition"/> <group delimiter=" "> <text term="volume" form="short"/> <number variable="volume" form="numeric"/> </group> <group delimiter=" "> <number variable="number-of-volumes" form="numeric"/> <text term="volume" form="short" plural="true"/> </group> <group delimiter=" "> <text term="issue" form="short"/> <number variable="issue" form="numeric"/> </group> </group> </macro> <macro name="title"> <choose> <if type="bill book graphic legal_case legislation motion_picture song" match="any"> <text variable="title" font-style="italic"/> </if> <else> <text variable="title" quotes="true"/> </else> </choose> </macro> <macro name="publisher"> <choose> <if type=" bill book chapter graphic legal_case legislation motion_picture paper-conference song" match="any"> <group delimiter=": "> <text variable="publisher-place"/> <text variable="publisher"/> </group> </if> <else> <group delimiter=", "> <text variable="publisher"/> <text variable="publisher-place"/> </group> </else> </choose> </macro> <macro name="event"> <choose> <if type="paper-conference speech" match="any"> <choose> <!-- Published Conference Paper --> <if variable="container-title"> <group delimiter=", "> <group delimiter=" "> <text term="in"/> <text variable="container-title" font-style="italic"/> </group> <text variable="event-place"/> </group> </if> <!-- Unpublished Conference Paper --> <else> <group delimiter=", "> <group delimiter=" "> <text term="presented at"/> <text variable="event"/> </group> <text variable="event-place"/> </group> </else> </choose> </if> </choose> </macro> <macro name="access"> <choose> <if type="webpage"> <choose> <if variable="URL"> <group delimiter=". "> <text term="online" prefix="[" suffix="]" text-case="capitalize-first"/> <group delimiter=": "> <text term="available at" text-case="capitalize-first"/> <text variable="URL"/> </group> <group prefix="[" suffix="]" delimiter=": "> <text term="accessed" text-case="capitalize-first"/> <date variable="accessed"> <date-part name="day" form="numeric-leading-zeros" suffix="-"/> <date-part name="month" form="short" suffix="-" strip-periods="true"/> <date-part name="year" form="long"/> </date> </group> </group> </if> </choose> </if> </choose> </macro> <macro name="page"> <group> <label variable="page" form="short" suffix=" "/> <text variable="page"/> </group> </macro> <macro name="citation-locator"> <group delimiter=" "> <choose> <if locator="page"> <label variable="locator" form="short"/> </if> <else> <label variable="locator" form="short" text-case="capitalize-first"/> </else> </choose> <text variable="locator"/> </group> </macro> <!-- Citation --> <citation collapse="citation-number"> <sort> <key variable="citation-number"/> </sort> <layout delimiter=", "> <group prefix="[" suffix="]" delimiter=", "> <text variable="citation-number"/> <text macro="citation-locator"/> </group> </layout> </citation> <!-- Bibliography --> <bibliography entry-spacing="0" second-field-align="flush"> <layout suffix="."> <!-- Citation Number --> <text variable="citation-number" prefix="[" suffix="]"/> <!-- Author(s) --> <text macro="author" suffix=", "/> <!-- Rest of Citation --> <choose> <!-- Specific Formats --> <if type="article-journal"> <group delimiter=", "> <text macro="title"/> <text variable="container-title" font-style="italic" form="short"/> <text macro="locators"/> <text macro="page"/> <text macro="issued"/> </group> </if> <else-if type="paper-conference speech" match="any"> <group delimiter=", "> <text macro="title"/> <text macro="event"/> <text macro="issued"/> <text macro="locators"/> <text macro="page"/> </group> </else-if> <else-if type="report"> <group delimiter=", "> <text macro="title"/> <text macro="publisher"/> <group delimiter=" "> <text variable="genre"/> <text variable="number"/> </group> <text macro="issued"/> </group> </else-if> <else-if type="thesis"> <group delimiter=", "> <text macro="title"/> <text variable="genre"/> <text macro="publisher"/> <text macro="issued"/> </group> </else-if> <else-if type="webpage post-weblog" match="any"> <group delimiter=", " suffix=". "> <text macro="title"/> <text variable="container-title" font-style="italic"/> <text macro="issued"/> </group> <text macro="access"/> </else-if> <else-if type="patent"> <group delimiter=", "> <text macro="title"/> <text variable="number"/> <text macro="issued"/> </group> </else-if> <!-- Generic/Fallback Formats --> <else-if type="bill book graphic legal_case legislation motion_picture report song" match="any"> <group delimiter=", " suffix=". "> <text macro="title"/> <text macro="locators"/> </group> <group delimiter=", "> <text macro="publisher"/> <text macro="issued"/> <text macro="page"/> </group> </else-if> <else-if type="article-magazine article-newspaper broadcast interview manuscript map patent personal_communication song speech thesis webpage" match="any"> <group delimiter=", "> <text macro="title"/> <text variable="container-title" font-style="italic"/> <text macro="locators"/> <text macro="publisher"/> <text macro="page"/> <text macro="issued"/> </group> </else-if> <else-if type="chapter paper-conference" match="any"> <group delimiter=", " suffix=", "> <text macro="title"/> <group delimiter=" "> <text term="in"/> <text variable="container-title" font-style="italic"/> </group> <text macro="locators"/> </group> <text macro="editor" suffix=" "/> <group delimiter=", "> <text macro="publisher"/> <text macro="issued"/> <text macro="page"/> </group> </else-if> <else> <group delimiter=", " suffix=". "> <text macro="title"/> <text variable="container-title" font-style="italic"/> <text macro="locators"/> </group> <group delimiter=", "> <text macro="publisher"/> <text macro="page"/> <text macro="issued"/> </group> </else> </choose> </layout> </bibliography> </style> `;
  chicago:string =`<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="note" version="1.0" demote-non-dropping-particle="display-and-sort" page-range-format="chicago"> <info> <title>Chicago Manual of Style 16th edition (full note)</title> <id>http://www.zotero.org/styles/chicago-fullnote-bibliography</id> <link href="http://www.zotero.org/styles/chicago-fullnote-bibliography" rel="self"/> <link href="http://www.chicagomanualofstyle.org/tools_citationguide.html" rel="documentation"/> <author> <name>Julian Onions</name> <email>julian.onions@gmail.com</email> </author> <contributor> <name>Simon Kornblith</name> <email>simon@simonster.com</email> </contributor> <contributor> <name>Elena Razlogova</name> <email>elena.razlogova@gmail.com</email> </contributor> <contributor> <name>Frank Bennett</name> <email>biercenator@gmail.com</email> </contributor> <contributor> <name>Andrew Dunning</name> <email>andrew.dunning@utoronto.ca</email> </contributor> <category citation-format="note"/> <category field="generic-base"/> <summary>Chicago format with full notes and bibliography</summary> <updated>2016-11-03T13:30:08+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <locale xml:lang="en"> <terms> <term name="editor" form="verb-short">ed.</term> <term name="translator" form="verb-short">trans.</term> <term name="translator" form="short">trans.</term> <term name="editortranslator" form="verb-short"> <single>ed. and trans.</single> <multiple>ed. and trans.</multiple> </term> <term name="editortranslator" form="verb"> <single>Edited and translated by</single> <multiple>Edited and translated by</multiple> </term> <term name="translator" form="short">trans.</term> </terms> </locale> <macro name="editor-translator"> <group delimiter=", "> <group delimiter=" "> <choose> <if variable="container-author reviewed-author" match="any"> <group> <names variable="container-author reviewed-author"> <label form="verb-short" text-case="lowercase" suffix=" "/> <name and="text" delimiter=", "/> </names> </group> </if> </choose> </group> <names variable="editor translator" delimiter=", "> <label form="verb-short" text-case="lowercase" suffix=" "/> <name and="text" delimiter=", "/> </names> </group> </macro> <macro name="secondary-contributors-note"> <choose> <if type="chapter paper-conference" match="none"> <text macro="editor-translator"/> </if> </choose> </macro> <macro name="container-contributors-note"> <choose> <if type="chapter paper-conference" match="any"> <text macro="editor-translator"/> </if> </choose> </macro> <macro name="secondary-contributors"> <choose> <if type="chapter paper-conference" match="none"> <names variable="editor translator" delimiter=". "> <label form="verb" text-case="capitalize-first" suffix=" "/> <name and="text" delimiter=", "/> </names> </if> </choose> </macro> <macro name="container-contributors"> <choose> <if type="chapter paper-conference" match="any"> <group delimiter=", "> <choose> <if variable="author"> <choose> <if variable="container-author" match="any"> <names variable="container-author"> <label form="verb-short" text-case="lowercase" suffix=" "/> <name and="text" delimiter=", "/> </names> </if> </choose> <!--This includes page numers after the container author, e.g. for Introductions --> <choose> <if variable="container-author author" match="all"> <group delimiter=". "> <text variable="page"/> <names variable="editor translator" delimiter=", "> <label form="verb" suffix=" "/> <name and="text" delimiter=", "/> </names> </group> </if> <else> <names variable="editor translator" delimiter=", "> <label form="verb" text-case="lowercase" suffix=" "/> <name and="text" delimiter=", "/> </names> </else> </choose> </if> </choose> </group> </if> </choose> </macro> <macro name="recipient-note"> <names variable="recipient" delimiter=", "> <label form="verb" text-case="lowercase" suffix=" "/> <name and="text" delimiter=", "/> </names> </macro> <macro name="contributors-note"> <group delimiter=" "> <names variable="author"> <name and="text" sort-separator=", " delimiter=", "/> <label form="short" prefix=", "/> <substitute> <names variable="editor"/> <names variable="translator"/> </substitute> </names> <text macro="recipient-note"/> </group> </macro> <macro name="editor"> <names variable="editor"> <name name-as-sort-order="first" and="text" sort-separator=", " delimiter=", " delimiter-precedes-last="always"/> <label form="short" prefix=", "/> </names> </macro> <macro name="translator"> <names variable="translator"> <name name-as-sort-order="first" and="text" sort-separator=", " delimiter=", " delimiter-precedes-last="always"/> <label form="verb-short" prefix=", "/> </names> </macro> <macro name="recipient"> <group delimiter=" "> <choose> <if type="personal_communication"> <choose> <if variable="genre"> <text variable="genre" text-case="capitalize-first"/> </if> <else> <text term="letter" text-case="capitalize-first"/> </else> </choose> </if> </choose> <text macro="recipient-note"/> </group> </macro> <macro name="contributors"> <group delimiter=". "> <names variable="author"> <name name-as-sort-order="first" and="text" sort-separator=", " delimiter=", " delimiter-precedes-last="always"/> <substitute> <text macro="editor"/> <text macro="translator"/> </substitute> </names> <text macro="recipient"/> </group> </macro> <macro name="recipient-short"> <names variable="recipient"> <label form="verb" text-case="lowercase" suffix=" "/> <name form="short" and="text" delimiter=", "/> </names> </macro> <macro name="contributors-short"> <group delimiter=" "> <names variable="author"> <name form="short" and="text" delimiter=", "/> <substitute> <names variable="editor"/> <names variable="translator"/> </substitute> </names> <text macro="recipient-short"/> </group> </macro> <macro name="contributors-sort"> <names variable="author"> <name name-as-sort-order="all" and="text" sort-separator=", " delimiter=", " delimiter-precedes-last="always"/> <substitute> <names variable="editor"/> <names variable="translator"/> <text macro="title"/> </substitute> </names> </macro> <macro name="interviewer-note"> <names variable="interviewer" delimiter=", "> <label form="verb" text-case="lowercase" suffix=" "/> <name and="text" delimiter=", "/> </names> </macro> <macro name="interviewer"> <names variable="interviewer" delimiter=", "> <label form="verb" text-case="capitalize-first" suffix=" "/> <name and="text" delimiter=", "/> </names> </macro> <macro name="title-note"> <choose> <if variable="title" match="none"> <text variable="genre"/> </if> <else-if type="book graphic motion_picture song" match="any"> <text variable="title" text-case="title" font-style="italic"/> <group delimiter=" " prefix=", "> <text term="version"/> <text variable="version"/> </group> </else-if> <else-if type="legal_case interview patent" match="any"> <text variable="title"/> </else-if> <else-if variable="reviewed-author"> <text variable="title" font-style="italic" prefix="review of "/> </else-if> <else> <text variable="title" text-case="title" quotes="true"/> </else> </choose> </macro> <macro name="title"> <choose> <if variable="title" match="none"> <choose> <if type="personal_communication" match="none"> <text variable="genre" text-case="capitalize-first"/> </if> </choose> </if> <else-if type="book graphic motion_picture song" match="any"> <text variable="title" text-case="title" font-style="italic"/> <group prefix=" (" suffix=")" delimiter=" "> <text term="version"/> <text variable="version"/> </group> </else-if> <else-if variable="reviewed-author"> <group delimiter=", "> <text variable="title" font-style="italic" prefix="Review of "/> <names variable="reviewed-author"> <label form="verb-short" text-case="lowercase" suffix=" "/> <name and="text" delimiter=", "/> </names> </group> </else-if> <else-if type="bill legislation legal_case interview patent" match="any"> <text variable="title"/> </else-if> <else> <text variable="title" text-case="title" quotes="true"/> </else> </choose> </macro> <macro name="title-short"> <choose> <if variable="title" match="none"> <choose> <if type="interview"> <text term="interview"/> </if> <else-if type="manuscript speech" match="any"> <text variable="genre" form="short"/> </else-if> <else-if type="personal_communication"> <text macro="issued"/> </else-if> </choose> </if> <else-if type="book graphic motion_picture song" match="any"> <text variable="title" text-case="title" form="short" font-style="italic"/> </else-if> <else-if type="legal_case" variable="title-short" match="all"> <text variable="title" font-style="italic" form="short"/> </else-if> <else-if type="patent interview" match="any"> <text variable="title" form="short"/> </else-if> <else-if type="legal_case bill legislation" match="any"> <text variable="title"/> </else-if> <else> <text variable="title" text-case="title" form="short" quotes="true"/> </else> </choose> </macro> <macro name="date-disambiguate"> <choose> <if disambiguate="true"> <text macro="issued"/> </if> </choose> </macro> <macro name="description-note"> <group delimiter=", "> <text macro="interviewer-note"/> <text variable="medium"/> <choose> <if variable="title" match="none"/> <else-if type="manuscript thesis speech" match="any"/> <else-if type="patent"> <group delimiter=" "> <text variable="authority"/> <text variable="number"/> </group> </else-if> <else> <text variable="genre"/> </else> </choose> </group> </macro> <macro name="description"> <group delimiter=", "> <group delimiter=". "> <text macro="interviewer"/> <text variable="medium" text-case="capitalize-first"/> </group> <choose> <if variable="title" match="none"/> <else-if type="thesis speech" match="any"/> <else-if type="patent"> <group delimiter=" "> <text variable="authority"/> <text variable="number"/> </group> </else-if> <else> <text variable="genre" text-case="capitalize-first"/> </else> </choose> </group> </macro> <macro name="container-title-note"> <group delimiter=" "> <choose> <if type="chapter paper-conference" match="any"> <text term="in"/> </if> </choose> <choose> <if type="bill legislation legal_case" match="none"> <text variable="container-title" text-case="title" font-style="italic"/> </if> </choose> </group> </macro> <macro name="container-title"> <group delimiter=" "> <choose> <if type="chapter paper-conference" match="any"> <text term="in" text-case="capitalize-first"/> </if> </choose> <choose> <if type="bill legislation legal_case" match="none"> <text variable="container-title" text-case="title" font-style="italic"/> </if> </choose> </group> </macro> <macro name="collection-title"> <choose> <if match="none" type="article-journal"> <choose> <if match="none" is-numeric="collection-number"> <group delimiter=", "> <text variable="collection-title" text-case="title"/> <text variable="collection-number"/> </group> </if> <else> <group delimiter=" "> <text variable="collection-title" text-case="title"/> <text variable="collection-number"/> </group> </else> </choose> </if> </choose> </macro> <macro name="collection-title-journal"> <choose> <if type="article-journal"> <group delimiter=" "> <text variable="collection-title"/> <text variable="collection-number"/> </group> </if> </choose> </macro> <macro name="edition-note"> <choose> <if type="book chapter graphic motion_picture paper-conference report song" match="any"> <choose> <if is-numeric="edition"> <group delimiter=" "> <number variable="edition" form="ordinal"/> <text term="edition" form="short"/> </group> </if> <else> <text variable="edition"/> </else> </choose> </if> </choose> </macro> <macro name="edition"> <choose> <if type="book chapter graphic motion_picture paper-conference report song" match="any"> <choose> <if is-numeric="edition"> <group delimiter=" "> <number variable="edition" form="ordinal"/> <text term="edition" form="short"/> </group> </if> <else> <text variable="edition" text-case="capitalize-first" suffix="."/> </else> </choose> </if> </choose> </macro> <macro name="locators-note-join-with-space"> <choose> <if type="article-journal" variable="volume" match="all"> <choose> <if match="none" variable="collection-title"> <text macro="locators-note"/> </if> </choose> </if> </choose> </macro> <macro name="locators-note-join-with-comma"> <choose> <if type="article-journal" match="none"> <text macro="locators-note"/> </if> <else-if type="article-journal"> <choose> <if variable="volume" match="none"> <text macro="locators-note"/> </if> <else-if match="any" variable="collection-title"> <text macro="locators-note"/> </else-if> </choose> </else-if> </choose> </macro> <macro name="locators-note"> <choose> <if type="article-journal"> <group delimiter=", "> <text macro="collection-title-journal"/> <number variable="volume"/> <group delimiter=" "> <text term="issue" form="short"/> <number variable="issue"/> </group> </group> </if> <else-if type="bill legislation legal_case" match="any"> <text macro="legal-cites"/> </else-if> <else-if type="book chapter graphic motion_picture paper-conference report song" match="any"> <group delimiter=", "> <text macro="edition-note"/> <group delimiter=" "> <text term="volume" form="short"/> <number variable="volume" form="numeric"/> </group> <choose> <if variable="locator" match="none"> <group delimiter=" "> <number variable="number-of-volumes" form="numeric"/> <text term="volume" form="short" plural="true"/> </group> </if> </choose> </group> </else-if> </choose> </macro> <macro name="legal-cites"> <choose> <if type="legal_case" match="any"> <group delimiter=" "> <choose> <if variable="container-title"> <text variable="volume"/> <text variable="container-title"/> <group delimiter=" "> <!--change to label variable="section" as that becomes available --> <text term="section" form="symbol"/> <text variable="section"/> </group> <text variable="page"/> </if> <else> <text variable="number" prefix="No. "/> </else> </choose> </group> </if> <else-if type="bill legislation" match="any"> <group delimiter=", "> <choose> <if variable="number"> <!--There's a public law number--> <text variable="number" prefix="Pub. L. No. "/> <group delimiter=" "> <!--change to label variable="section" as that becomes available --> <text term="section" form="symbol"/> <text variable="section"/> </group> <group delimiter=" "> <text variable="volume"/> <text variable="container-title"/> <text variable="page-first"/> </group> </if> <else> <group delimiter=" "> <text variable="volume"/> <text variable="container-title"/> <!--change to label variable="section" as that becomes available --> <text term="section" form="symbol"/> <text variable="section"/> </group> </else> </choose> </group> </else-if> </choose> </macro> <macro name="locators-join-with-space"> <choose> <if type="article-journal" variable="volume" match="all"> <choose> <if match="none" variable="collection-title"> <text macro="locators"/> </if> </choose> </if> </choose> </macro> <macro name="locators-join-with-comma"> <choose> <if type="bill chapter legislation legal_case paper-conference" match="any"> <text macro="locators"/> </if> <else-if type="article-journal"> <choose> <if variable="volume" match="none"> <text macro="locators"/> </if> <else-if match="any" variable="collection-title"> <text macro="locators"/> </else-if> </choose> </else-if> </choose> </macro> <macro name="locators-join-with-period"> <choose> <if type="bill legislation legal_case article-journal chapter paper-conference" match="none"> <text macro="locators"/> </if> </choose> </macro> <macro name="locators"> <choose> <if type="article-journal"> <group delimiter=", "> <text macro="collection-title-journal"/> <number variable="volume"/> <group delimiter=" "> <text term="issue" form="short"/> <number variable="issue"/> </group> </group> </if> <else-if type="bill legislation legal_case" match="any"> <text macro="legal-cites"/> </else-if> <else-if type="book graphic motion_picture report song" match="any"> <group delimiter=". "> <text macro="edition"/> <group delimiter=" "> <text term="volume" form="short" text-case="capitalize-first"/> <number variable="volume" form="numeric"/> </group> <group delimiter=" "> <number variable="number-of-volumes" form="numeric"/> <text term="volume" form="short" plural="true"/> </group> </group> </else-if> <else-if type="chapter paper-conference" match="any"> <group delimiter=". "> <text macro="edition"/> <choose> <if variable="page" match="none"> <group delimiter=" "> <text term="volume" form="short" text-case="capitalize-first"/> <number variable="volume" form="numeric"/> </group> </if> </choose> </group> </else-if> </choose> </macro> <macro name="locators-newspaper"> <choose> <if type="article-newspaper"> <group delimiter=", "> <group delimiter=" "> <number variable="edition"/> <text term="edition"/> </group> <group delimiter=" "> <text term="section" form="short"/> <text variable="section"/> </group> </group> </if> </choose> </macro> <macro name="event-note"> <text variable="event"/> </macro> <macro name="event"> <choose> <if variable="title"> <group delimiter=" "> <text term="presented at"/> <text variable="event"/> </group> </if> <else> <group delimiter=" "> <text term="presented at" text-case="capitalize-first"/> <text variable="event"/> </group> </else> </choose> </macro> <macro name="originally-published"> <group delimiter=", "> <group delimiter=": "> <text variable="original-publisher-place"/> <text variable="original-publisher"/> </group> <date variable="original-date" form="text" date-parts="year"/> </group> </macro> <macro name="reprint-note"> <!--needs localization--> <choose> <if variable="original-date issued" match="all"> <choose> <!--for whatever reason in notes, when we have both original and new publishers, reprint doesn't appear--> <if variable="original-publisher original-publisher-place" match="none"> <text value="repr."/> </if> </choose> </if> </choose> </macro> <macro name="reprint"> <!--needs localization--> <choose> <if variable="original-date issued" match="all"> <text value="reprint" text-case="capitalize-first"/> </if> </choose> </macro> <macro name="publisher"> <choose> <if type="thesis"> <text variable="publisher"/> </if> <else-if type="speech"> <text variable="event-place"/> </else-if> <else> <group delimiter=": "> <text variable="publisher-place"/> <text variable="publisher"/> </group> </else> </choose> </macro> <macro name="issued"> <choose> <if variable="issued"> <choose> <if type="graphic report" match="any"> <date variable="issued" form="text"/> </if> <else-if type="legal_case"> <group delimiter=" "> <text variable="authority"/> <choose> <if variable="container-title" match="any"> <!--Only print year for cases published in reporters--> <date variable="issued" form="numeric" date-parts="year"/> </if> <else> <date variable="issued" form="text"/> </else> </choose> </group> </else-if> <else-if type="book bill chapter graphic legislation motion_picture paper-conference report song thesis" match="any"> <date variable="issued"> <date-part name="year"/> </date> </else-if> <else-if type="patent"> <group delimiter=", "> <group delimiter=" "> <!--Needs Localization--> <text value="filed"/> <date variable="submitted" form="text"/> </group> <group delimiter=" "> <choose> <if variable="issued submitted" match="all"> <text term="and"/> </if> </choose> <!--Needs Localization--> <text value="issued"/> <date variable="issued" form="text"/> </group> </group> </else-if> <else> <date variable="issued" form="text"/> </else> </choose> </if> <else-if variable="status"> <text variable="status"/> </else-if> <else-if variable="accessed URL" match="all"/> <else> <text term="no date" form="short"/> </else> </choose> </macro> <macro name="point-locators-subsequent"> <choose> <if type="legal_case" variable="locator" match="all"> <choose> <if locator="page"> <group delimiter=":"> <number variable="volume"/> <text variable="locator"/> </group> </if> <else> <group delimiter=" "> <label variable="locator" form="short"/> <text variable="locator"/> </group> </else> </choose> </if> <else-if variable="locator"> <choose> <if locator="page" match="none"> <group delimiter=" "> <choose> <if type="book graphic motion_picture report song" match="any"> <choose> <if variable="volume"> <group delimiter=", "> <group delimiter=" "> <text term="volume" form="short"/> <number variable="volume" form="numeric"/> </group> <label variable="locator" form="short"/> </group> </if> <else> <label variable="locator" form="short"/> </else> </choose> </if> <else> <label variable="locator" form="short"/> </else> </choose> <text variable="locator"/> </group> </if> <else-if type="book graphic motion_picture report song" match="any"> <group delimiter=":"> <number variable="volume" form="numeric"/> <text variable="locator"/> </group> </else-if> <else> <text variable="locator"/> </else> </choose> </else-if> </choose> </macro> <macro name="point-locators-join-with-colon"> <choose> <if type="article-journal"> <choose> <if variable="locator page" match="any"> <choose> <if variable="volume issue" match="any"> <text macro="point-locators"/> </if> </choose> </if> </choose> </if> </choose> </macro> <macro name="point-locators-join-with-comma"> <choose> <if type="article-journal" match="none"> <text macro="point-locators"/> </if> <else-if variable="volume issue" match="none"> <text macro="point-locators"/> </else-if> </choose> </macro> <macro name="point-locators"> <choose> <if variable="locator" match="none"> <choose> <if type="article-journal chapter paper-conference" match="any"> <text variable="page"/> </if> </choose> </if> <else-if type="article-journal"> <group delimiter=" "> <choose> <if locator="page" match="none"> <label variable="locator" form="short" suffix=" "/> </if> </choose> <text variable="locator"/> </group> </else-if> <else-if type="legal_case"/> <else> <group delimiter=" "> <choose> <if locator="page" match="none"> <label variable="locator" form="short"/> </if> </choose> <text variable="locator"/> </group> </else> </choose> </macro> <macro name="locators-chapter"> <choose> <if type="chapter paper-conference" match="any"> <choose> <if variable="author container-author" match="all"/> <else> <choose> <if variable="page"> <number variable="volume" suffix=":"/> <text variable="page"/> </if> </choose> </else> </choose> </if> </choose> </macro> <macro name="locators-journal-join-with-colon"> <choose> <if type="article-journal"> <choose> <if variable="volume issue" match="any"> <text variable="page"/> </if> </choose> </if> </choose> </macro> <macro name="locators-journal-join-with-comma"> <choose> <if type="article-journal"> <choose> <if variable="volume issue" match="none"> <text variable="page"/> </if> </choose> </if> </choose> </macro> <macro name="archive-note"> <choose> <if type="thesis"> <group delimiter=" "> <text variable="archive"/> <text variable="archive_location" prefix="(" suffix=")"/> </group> </if> <else> <group delimiter=", "> <text variable="archive_location"/> <text variable="archive"/> <text variable="archive-place"/> </group> </else> </choose> </macro> <macro name="archive"> <choose> <if type="thesis"> <group delimiter=" "> <text variable="archive"/> <text variable="archive_location" prefix="(" suffix=")"/> </group> </if> <else> <group delimiter=". "> <text variable="archive_location" text-case="capitalize-first"/> <text variable="archive"/> <text variable="archive-place"/> </group> </else> </choose> </macro> <macro name="issue-note-join-with-space"> <choose> <if type="article-journal bill legislation legal_case manuscript thesis" variable="publisher-place publisher" match="any"> <!--Chicago doesn't use publisher/place for Newspapers and we want the date delimited by a comma--> <choose> <if type="article-newspaper" match="none"> <choose> <if type="article-journal" match="none"> <text macro="issue-note"/> </if> <else-if variable="issue volume" match="any"> <text macro="issue-note"/> </else-if> </choose> </if> </choose> </if> </choose> </macro> <macro name="issue-note-join-with-comma"> <choose> <if type="article-journal bill legislation legal_case manuscript thesis" variable="publisher-place publisher" match="none"> <text macro="issue-note"/> </if> <else-if type="article-newspaper"> <text macro="issue-note"/> </else-if> <else-if type="article-journal"> <choose> <if variable="volume issue" match="none"> <text macro="issue-note"/> </if> </choose> </else-if> </choose> </macro> <macro name="issue-note"> <choose> <if type="bill legislation legal_case" match="any"> <text macro="issued" prefix="(" suffix=")"/> </if> <else-if type="article-journal"> <choose> <if variable="volume issue" match="any"> <text macro="issued" prefix="(" suffix=")"/> </if> <else> <text macro="issued"/> </else> </choose> </else-if> <else-if type="article-newspaper"> <text macro="issued"/> </else-if> <else-if variable="publisher-place event-place publisher genre" match="any"> <group prefix="(" suffix=")" delimiter=", "> <choose> <if variable="title" match="none"/> <else-if type="manuscript thesis speech" match="any"> <text variable="genre"/> </else-if> </choose> <text macro="event-note"/> <group delimiter="; "> <text macro="originally-published"/> <group delimiter=", "> <text macro="reprint-note"/> <text macro="publisher"/> </group> </group> <text macro="issued"/> </group> </else-if> <else> <text macro="issued"/> </else> </choose> </macro> <macro name="issue-join-with-space"> <choose> <if type="article-journal" match="any"> <choose> <if variable="issue volume" match="any"> <text macro="issue"/> </if> </choose> </if> <else-if type="bill legislation legal_case" match="any"> <text macro="issue"/> </else-if> </choose> </macro> <macro name="issue-join-with-period"> <choose> <if type="article-journal bill legislation legal_case" match="none"> <choose> <if type="speech" variable="publisher publisher-place" match="any"> <text macro="issue"/> </if> </choose> </if> </choose> </macro> <macro name="issue-join-with-comma"> <choose> <if type="bill legislation legal_case" match="none"> <choose> <if type="article-journal" match="none"> <choose> <if type="speech" variable="publisher publisher-place" match="none"> <text macro="issue"/> </if> </choose> </if> <else-if variable="volume issue" match="none"> <text macro="issue"/> </else-if> </choose> </if> </choose> </macro> <macro name="issue"> <choose> <if type="bill legislation legal_case" match="any"> <text macro="issued" prefix="(" suffix=")"/> </if> <else-if type="article-journal"> <choose> <if variable="issue volume" match="any"> <text macro="issued" prefix="(" suffix=")"/> </if> <else> <text macro="issued"/> </else> </choose> </else-if> <else-if type="speech"> <group delimiter=", "> <group delimiter=" "> <choose> <if variable="title" match="none"/> <else> <text variable="genre" text-case="capitalize-first"/> </else> </choose> <text macro="event"/> </group> <text variable="event-place"/> <text macro="issued"/> </group> </else-if> <!--Chicago doesn't use publisher/place for Newspapers --> <else-if type="article-newspaper"> <text macro="issued"/> </else-if> <else-if variable="publisher-place publisher" match="any"> <group delimiter=", "> <choose> <if type="thesis"> <text variable="genre" text-case="capitalize-first"/> </if> </choose> <group delimiter=". "> <text macro="originally-published"/> <group delimiter=", "> <text macro="reprint"/> <text macro="publisher"/> </group> </group> <text macro="issued"/> </group> </else-if> <else> <text macro="issued"/> </else> </choose> </macro> <macro name="access-note"> <group delimiter=", "> <choose> <if type="graphic report" match="any"> <text macro="archive-note"/> </if> <else-if type="article-journal bill book chapter legal_case legislation motion_picture paper-conference" match="none"> <text macro="archive-note"/> </else-if> </choose> <choose> <if variable="issued" match="none"> <group delimiter=" "> <text term="accessed"/> <date variable="accessed" form="text"/> </group> </if> </choose> <choose> <if type="legal_case" match="none"> <choose> <if variable="DOI"> <text variable="DOI" prefix="doi:"/> </if> <else> <text variable="URL"/> </else> </choose> </if> </choose> </group> </macro> <macro name="access"> <group delimiter=". "> <choose> <if type="graphic report" match="any"> <text macro="archive"/> </if> <else-if type="article-journal bill book chapter legal_case legislation motion_picture paper-conference" match="none"> <text macro="archive"/> </else-if> </choose> <choose> <if variable="issued" match="none"> <group delimiter=" "> <text term="accessed" text-case="capitalize-first"/> <date variable="accessed" form="text"/> </group> </if> </choose> <choose> <if type="legal_case" match="none"> <choose> <if variable="DOI"> <text variable="DOI" prefix="doi:"/> </if> <else> <text variable="URL"/> </else> </choose> </if> </choose> </group> </macro> <macro name="case-locator-subsequent"> <choose> <if type="legal_case"> <group delimiter=" "> <text variable="volume"/> <text variable="container-title"/> </group> </if> </choose> </macro> <macro name="case-pinpoint-subsequent"> <choose> <if type="legal_case"> <group delimiter=" "> <choose> <if locator="page"> <text term="at"/> <text variable="locator"/> </if> <else> <label variable="locator"/> <text variable="locator"/> </else> </choose> </group> </if> </choose> </macro> <citation et-al-min="4" et-al-use-first="1" disambiguate-add-names="true"> <layout suffix="." delimiter="; "> <choose> <if position="ibid-with-locator"> <group delimiter=", "> <text term="ibid"/> <text macro="point-locators-subsequent"/> </group> </if> <else-if position="ibid"> <text term="ibid"/> </else-if> <else-if position="subsequent"> <group delimiter=", "> <text macro="contributors-short"/> <group delimiter=" "> <group delimiter=", "> <text macro="title-short"/> <!--if title & author are the same: --> <text macro="date-disambiguate"/> <text macro="case-locator-subsequent"/> </group> <text macro="case-pinpoint-subsequent"/> </group> <choose> <if match="none" type="legal_case"> <text macro="point-locators-subsequent"/> </if> </choose> </group> </else-if> <else> <group delimiter=", "> <group delimiter=": "> <group delimiter=", "> <group delimiter=" "> <group delimiter=", "> <group delimiter=" "> <group delimiter=", "> <group delimiter=", "> <text macro="contributors-note"/> <text macro="title-note"/> </group> <text macro="description-note"/> <text macro="secondary-contributors-note"/> <text macro="container-title-note"/> <text macro="container-contributors-note"/> </group> <text macro="locators-note-join-with-space"/> </group> <text macro="locators-note-join-with-comma"/> <text macro="collection-title"/> <text macro="issue-note-join-with-comma"/> </group> <text macro="issue-note-join-with-space"/> </group> <text macro="locators-newspaper"/> <text macro="point-locators-join-with-comma"/> </group> <text macro="point-locators-join-with-colon"/> </group> <text macro="access-note"/> </group> </else> </choose> </layout> </citation> <bibliography hanging-indent="true" et-al-min="11" et-al-use-first="7" subsequent-author-substitute="&#8212;&#8212;&#8212;" entry-spacing="0"> <sort> <key macro="contributors-sort"/> <key variable="title"/> <key variable="genre"/> <key variable="issued"/> </sort> <layout suffix="."> <group delimiter=". "> <group delimiter=": "> <group delimiter=", "> <group delimiter=" "> <group delimiter=". "> <group delimiter=" "> <group delimiter=", "> <group delimiter=". "> <group delimiter=". "> <text macro="contributors"/> <text macro="title"/> </group> <text macro="description"/> <text macro="secondary-contributors"/> <group delimiter=", "> <text macro="container-title"/> <text macro="container-contributors"/> </group> <text macro="locators-join-with-period"/> </group> <text macro="locators-join-with-comma"/> <text macro="locators-chapter"/> </group> <text macro="locators-join-with-space"/> </group> <text macro="collection-title"/> <text macro="issue-join-with-period"/> </group> <text macro="issue-join-with-space"/> </group> <text macro="issue-join-with-comma"/> <text macro="locators-journal-join-with-comma"/> <text macro="locators-newspaper"/> </group> <text macro="locators-journal-join-with-colon"/> </group> <text macro="access"/> </group> </layout> </bibliography> </style> `;
  science:string ='<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only" default-locale="en-US"> <info> <title>Science</title> <id>http://www.zotero.org/styles/science</id> <link href="http://www.zotero.org/styles/science" rel="self"/> <link href="http://www.sciencemag.org/about/authors/prep/res/refs.dtl" rel="documentation"/> <author> <name>Julian Onions</name> <email>julian.onions@gmail.com</email> </author> <contributor> <name>Sebastian Karcher</name> </contributor> <contributor> <name>Greg Barendt</name> </contributor> <category citation-format="numeric"/> <category field="science"/> <issn>0036-8075</issn> <eissn>1095-9203</eissn> <summary>The Science journal style.</summary> <updated>2014-08-28T01:36:46+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <macro name="editor"> <names variable="editor" delimiter=", "> <name initialize-with=". " delimiter=", " delimiter-precedes-last="always"/> <label form="short" prefix=", " text-case="capitalize-first"/> </names> </macro> <macro name="author"> <names variable="author"> <name sort-separator=", " initialize-with=". " delimiter=", " delimiter-precedes-last="always"/> <label form="short" prefix=", " text-case="capitalize-first"/> <et-al font-style="italic"/> <substitute> <names variable="editor"/> </substitute> </names> </macro> <macro name="access"> <choose> <if variable="page" match="none"> <text macro="access-value"/> </if> <else-if is-numeric="page" match="none"> <text macro="access-value"/> </else-if> </choose> </macro> <macro name="access-value"> <choose> <if variable="DOI"> <text variable="DOI" prefix=", doi:"/> </if> <else> <group prefix=" (" suffix=")"> <text value="available at "/> <text variable="URL"/> </group> </else> </choose> </macro> <macro name="title"> <choose> <if type="bill book graphic legal_case legislation motion_picture report song" match="any"> <text variable="title" font-style="italic"/> </if> <else> <text variable="title"/> </else> </choose> </macro> <macro name="article-details"> <group delimiter=", "> <group delimiter=". "> <text macro="title"/> <text form="short" variable="container-title" font-style="italic"/> <text variable="volume" font-weight="bold"/> </group> <text variable="page"/> </group> <text macro="issued" prefix=" (" suffix=")"/> <text macro="access"/> </macro> <macro name="publisher"> <group delimiter=", "> <text variable="publisher"/> <text variable="publisher-place"/> </group> </macro> <macro name="pages"> <label variable="page" form="short" suffix=" "/> <text variable="page" form="short"/> </macro> <macro name="issued"> <date variable="issued" delimiter=" "> <date-part name="year"/> </date> </macro> <macro name="edition"> <choose> <if is-numeric="edition"> <group delimiter=" "> <text term="edition" form="short"/> <number variable="edition" form="numeric"/> </group> </if> <else> <text variable="edition" suffix="."/> </else> </choose> </macro> <citation collapse="citation-number"> <sort> <key variable="citation-number"/> </sort> <layout prefix="(" suffix=")" delimiter=", "> <text variable="citation-number" font-style="italic"/> </layout> </citation> <bibliography et-al-min="6" et-al-use-first="1" second-field-align="flush"> <layout suffix="."> <text variable="citation-number" suffix=". "/> <group delimiter=", "> <text macro="author"/> <choose> <if type="thesis"> <group delimiter=" "> <group delimiter=", "> <group> <!-- Always print, even if no university given --> <text value="thesis"/> </group> <text macro="publisher"/> </group> <text macro="issued" prefix="(" suffix=")"/> </group> </if> <else-if type="bill book graphic legal_case legislation motion_picture song chapter paper-conference" match="any"> <group delimiter=" "> <choose> <if type="chapter paper-conference" match="any"> <group delimiter=", "> <group delimiter=" "> <text term="in"/> <text variable="container-title" font-style="italic"/> </group> <text macro="editor"/> </group> </if> <else> <text macro="title"/> </else> </choose> <group prefix="(" suffix=")" delimiter="; "> <group delimiter=", "> <text macro="publisher"/> <text macro="edition"/> <text macro="issued"/> </group> <text variable="URL"/> </group> </group> <group delimiter=" of "> <group> <label variable="volume" form="short" suffix=" "/> <number variable="volume"/> </group> <text variable="collection-title" font-style="italic"/> </group> <choose> <if type="chapter paper-conference" match="any"> <text macro="pages"/> </if> </choose> </else-if> <else-if type="article-journal"> <choose> <if variable="page"> <choose> <if is-numeric="page" match="none"> <group> <group delimiter=", "> <text variable="container-title" form="short" font-style="italic"/> <group> <text term="in press"/> </group> </group> <text macro="access"/> </group> </if> <else> <text macro="article-details"/> </else> </choose> </if> <else> <text macro="article-details"/> </else> </choose> </else-if> <else-if type="report"> <group> <group delimiter=", "> <text variable="title" quotes="true"/> <text variable="collection-title" font-style="italic"/> </group> <group prefix=" (" suffix=")" delimiter=", "> <group delimiter=" "> <text variable="genre" form="short"/> <number variable="number"/> </group> <text variable="publisher"/> <text variable="publisher-place"/> <text macro="issued"/> </group> </group> <text macro="pages"/> <text macro="access"/> </else-if> <else> <group> <group delimiter=", "> <text macro="editor"/> <group delimiter=". "> <text macro="title"/> <text form="short" variable="container-title" font-style="italic"/> <text variable="volume" font-weight="bold"/> </group> </group> <text macro="issued" prefix=" (" suffix=")"/> </group> <text macro="pages"/> <text macro="access"/> </else> </choose> </group> </layout> </bibliography> </style>';
  cell:string ='<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" version="1.0" class="in-text" default-locale="en-US" demote-non-dropping-particle="sort-only" page-range-format="expanded"> <info> <title>Cell</title> <id>http://www.zotero.org/styles/cell</id> <link href="http://www.zotero.org/styles/cell" rel="self"/> <link href="http://www.cell.com/authors" rel="documentation"/> <author> <name>Adam Mark</name> <email>a.mark@uoguelph.ca</email> </author> <contributor> <name>Julian Onions</name> <email>julian.onions@gmail.com</email> </contributor> <contributor> <name>Aurimas Vinckevicius</name> <email>aurimas.dev@gmail.com</email> </contributor> <category citation-format="author-date"/> <category field="biology"/> <issn>0092-8674</issn> <eissn>1097-4172</eissn> <summary>The Cell journal style. Original by Julian Onions.</summary> <updated>2013-01-26T22:06:38+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <macro name="author-short"> <names variable="author"> <name form="short" and="text"/> </names> </macro> <macro name="author-count"> <names variable="author"> <name form="count"/> </names> </macro> <macro name="author"> <names variable="author"> <name name-as-sort-order="all" initialize-with="." and="text" delimiter-precedes-last="always"/> </names> </macro> <macro name="issued"> <date variable="issued"> <date-part name="year"/> </date> </macro> <macro name="publisher"> <group prefix="(" delimiter=": " suffix=")"> <text variable="publisher-place"/> <text variable="publisher"/> </group> </macro> <macro name="editor"> <names variable="editor"> <name initialize-with="." and="text" delimiter-precedes-last="always"/> <label form="short" prefix=", "/> </names> </macro> <citation et-al-min="3" et-al-use-first="1" disambiguate-add-year-suffix="true" collapse="year"> <sort> <key macro="author-short" names-min="1" names-use-first="1"/> <key macro="author-count" names-min="3" names-use-first="3"/> <key macro="author" names-min="3" names-use-first="1"/> <key macro="issued"/> <key variable="title"/> </sort> <layout prefix="(" suffix=")" delimiter="; "> <group delimiter=", "> <text macro="author-short"/> <text macro="issued"/> </group> </layout> </citation> <bibliography et-al-min="11" et-al-use-first="10"> <sort> <key macro="author-short" names-min="1" names-use-first="1"/> <key macro="author-count" names-min="3" names-use-first="3"/> <key macro="author" names-min="3" names-use-first="1"/> <key macro="issued"/> </sort> <layout suffix="."> <group delimiter=" "> <text macro="author"/> <text macro="issued" prefix="(" suffix=")."/> <choose> <if type="article article-magazine article-newspaper article-journal review" match="any"> <text variable="title" suffix="."/> <text variable="container-title" form="short" text-case="title"/> <group delimiter=", "> <text variable="volume" font-style="italic"/> <text variable="page"/> </group> </if> <else-if type="chapter paper-conference" match="any"> <text variable="title" suffix="."/> <text variable="container-title" prefix="In " suffix="," text-case="title"/> <text macro="editor"/> <text macro="publisher" suffix=","/> <label variable="page" form="short"/> <text variable="page"/> </else-if> <else-if type="thesis"> <text variable="title" suffix="."/> <text variable="genre" suffix="."/> <text variable="publisher"/> </else-if> <else> <text variable="title"/> <text macro="publisher"/> </else> </choose> </group> </layout> </bibliography> </style> ';
  //mla is short version
  mla:string ='<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="never"> <info> <title>Modern Language Association 7th edition</title> <title-short>MLA</title-short> <id>http://www.zotero.org/styles/modern-language-association</id> <link href="http://www.zotero.org/styles/modern-language-association" rel="self"/> <link href="http://owl.english.purdue.edu/owl/section/2/11/" rel="documentation"/> <author> <name>Ilouise S. Bradford</name> <email>isbradford@gmail.com</email> </author> <contributor> <name>Sarah Ficke</name> <email>sficke@email.unc.edu</email> </contributor> <contributor> <name>Sebastian Karcher</name> <email>karcher@u.northwestern.edu</email> </contributor> <contributor> <name>Christian Werthschulte</name> <email>Christian.Werthschulte@rub.de</email> </contributor> <contributor> <name>Simon Kornblith</name> <email>simon@simonster.com</email> </contributor> <contributor> <name>James Johnston</name> <email>thejamesjohnston@gmail.com</email> </contributor> <category citation-format="author"/> <category field="generic-base"/> <summary>This style adheres to the MLA 7th edition handbook and contains modifications to these types of sources: e-mail, forum posts, interviews, manuscripts, maps, presentations, TV broadcasts, and web pages.</summary> <updated>2014-07-06T20:05:10+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <locale xml:lang="en"> <terms> <term name="month-01" form="short">Jan.</term> <term name="month-02" form="short">Feb.</term> <term name="month-03" form="short">Mar.</term> <term name="month-04" form="short">Apr.</term> <term name="month-05" form="short">May</term> <term name="month-06" form="short">June</term> <term name="month-07" form="short">July</term> <term name="month-08" form="short">Aug.</term> <term name="month-09" form="short">Sept.</term> <term name="month-10" form="short">Oct.</term> <term name="month-11" form="short">Nov.</term> <term name="month-12" form="short">Dec.</term> <term name="volume" form="short"> <single>Vol.</single> <multiple>vols</multiple> </term> <term name="edition" form="short">ed</term> <term name="editor" form="verb-short">ed.</term> <term name="translator" form="verb-short">trans.</term> <term name="translator" form="short">trans.</term> </terms> </locale> <macro name="editor-translator"> <names variable="editor translator" delimiter=". "> <label form="verb-short" text-case="capitalize-first" suffix=" "/> <name and="text" delimiter=", "/> </names> </macro> <macro name="author"> <names variable="author"> <name name-as-sort-order="first" and="text" sort-separator=", " delimiter=", " delimiter-precedes-last="always"/> <label form="short" prefix=", "/> <substitute> <names variable="editor"/> <names variable="translator"/> <text macro="title"/> </substitute> </names> </macro> <macro name="author-short"> <names variable="author"> <name form="short" and="text" delimiter=", " initialize-with=". "/> <substitute> <names variable="editor"/> <names variable="translator"/> <text macro="title-short"/> </substitute> </names> </macro> <macro name="access"> <group delimiter=" "> <date variable="accessed"> <date-part name="day" suffix=" "/> <date-part name="month" form="short" suffix=" "/> <date-part name="year"/> </date> </group> </macro> <macro name="issued-full-date"> <choose> <if variable="issued"> <date variable="issued"> <date-part name="day" suffix=" "/> <date-part name="month" form="short" suffix=" " strip-periods="false"/> <date-part name="year"/> </date> </if> <else> <text term="no date" form="short"/> </else> </choose> </macro> <macro name="medium"> <choose> <if type="motion_picture"> <choose> <if variable="medium"> <text variable="medium" prefix=" "/> </if> <else> <text value="Film" prefix=" "/> </else> </choose> </if> <else-if type="broadcast"> <choose> <if variable="medium"> <text variable="medium" prefix=" "/> </if> <else> <text value="Television" prefix=" "/> </else> </choose> </else-if> <else-if type="manuscript"> <text value=""/> </else-if> <else-if type="personal_communication" match="any"> <text value="" prefix=" "/> </else-if> <else-if type="speech" match="any"> <text value=""/> </else-if> <else-if type="interview"> <text variable="medium" prefix=" "/> </else-if> <else-if type="song"> <choose> <if variable="medium"> <text variable="medium" prefix=" "/> </if> <else> <text value="Audio Recording" prefix=" "/> </else> </choose> </else-if> <else> <choose> <if variable="URL DOI" match="any"> <text variable="source" prefix=" " suffix="." font-style="italic"/> <group> <text value="Web." prefix=" "/> </group> <text prefix=" " suffix="." macro="access"/> </if> <else> <text value="Print" prefix=" "/> </else> </choose> </else> </choose> </macro> <macro name="title"> <choose> <if type="bill book graphic legal_case legislation manuscript motion_picture report song" match="any"> <text variable="title" font-style="italic" text-case="title"/> </if> <else-if type="interview personal_communication" match="any"> <text variable="title" text-case="title" quotes="false"/> </else-if> <else> <text variable="title" text-case="title" quotes="true"/> </else> </choose> </macro> <macro name="title-short"> <choose> <if type="bill book graphic legal_case legislation manuscript motion_picture report song" match="any"> <text variable="title" text-case="title" form="short" font-style="italic"/> </if> <else> <text variable="title" text-case="title" form="short" quotes="true"/> </else> </choose> </macro> <macro name="pages"> <choose> <if variable="page"> <text variable="page"/> </if> <else-if type="personal_communication interview" match="any"> <text value=""/> </else-if> <else> <text value="n. pag"/> </else> </choose> </macro> <macro name="edition"> <choose> <if is-numeric="edition"> <group delimiter=" "> <number variable="edition" form="ordinal"/> <text term="edition" form="short"/> </group> </if> <else> <text variable="edition"/> </else> </choose> </macro> <macro name="volume"> <choose> <if is-numeric="volume"> <group delimiter=" "> <text term="volume" form="short" strip-periods="false"/> <number variable="volume"/> </group> </if> <else> <text variable="volume"/> </else> </choose> </macro> <macro name="number-of-volumes-only"> <choose> <if variable="volume" match="none"> <choose> <if is-numeric="number-of-volumes"> <group delimiter=" "> <number variable="number-of-volumes"/> <text term="volume" form="short" plural="true" strip-periods="true"/> </group> </if> <else> <text variable="number-of-volumes"/> </else> </choose> </if> </choose> </macro> <macro name="number-of-volumes-optional"> <choose> <if variable="volume"> <choose> <if is-numeric="number-of-volumes"> <group delimiter=" "> <number variable="number-of-volumes"/> <text term="volume" form="short" plural="true" strip-periods="true"/> </group> </if> <else> <text variable="number-of-volumes"/> </else> </choose> </if> </choose> </macro> <macro name="collection-title"> <text variable="collection-title" text-case="title" prefix=" "/> </macro> <macro name="collection-number"> <text variable="collection-number" prefix=" " suffix="."/> </macro> <macro name="publisher"> <choose> <if variable="publisher"> <text variable="publisher"/> </if> <else> <text value="N.p."/> </else> </choose> </macro> <macro name="publisher-year"> <group delimiter=", "> <group delimiter=": "> <text variable="publisher-place"/> <text macro="publisher"/> </group> <date variable="issued"> <date-part name="year"/> </date> </group> </macro> <citation et-al-min="4" et-al-use-first="1" disambiguate-add-names="true" disambiguate-add-givenname="true"> <layout prefix="(" suffix=")" delimiter="; "> <group delimiter=" "> <choose> <if variable="author editor translator" match="any"> <group delimiter=", "> <text macro="author-short"/> <choose> <if disambiguate="true"> <text macro="title-short"/> </if> </choose> </group> </if> <else> <text macro="title-short"/> </else> </choose> <text variable="locator"/> </group> </layout> </citation> <bibliography hanging-indent="true" et-al-min="4" et-al-use-first="1" line-spacing="2" entry-spacing="0" subsequent-author-substitute="---"> <sort> <key macro="author"/> <key variable="title"/> </sort> <layout suffix="."> <text macro="author" suffix="."/> <text macro="title" prefix=" " suffix="."/> <choose> <if type="bill book graphic legal_case legislation motion_picture report song" match="any"> <text macro="editor-translator" prefix=" " suffix="."/> <text macro="edition" prefix=" " suffix="."/> <text macro="volume" prefix=" " suffix="."/> <text macro="number-of-volumes-only" prefix=" " suffix="."/> <text macro="publisher-year" prefix=" " suffix="."/> </if> <else-if type="chapter paper-conference" match="any"> <group> <text variable="container-title" text-case="title" font-style="italic" prefix=" " suffix="."/> <text macro="editor-translator" prefix=" " suffix="."/> <text macro="edition" prefix=" " suffix="."/> <text macro="volume" prefix=" " suffix="."/> <text macro="number-of-volumes-only" prefix=" " suffix="."/> <text macro="publisher-year" prefix=" " suffix="."/> </group> <text variable="page" prefix=" " suffix="."/> </else-if> <else-if type="thesis"> <text variable="genre" prefix=" " suffix="."/> <group delimiter=", "> <text macro="publisher" prefix=" "/> <date variable="issued" prefix=" " suffix="."> <date-part name="year"/> </date> </group> <text variable="archive_location" prefix=" " suffix="."/> </else-if> <else-if type="manuscript"> <date variable="issued" prefix=" " suffix="."> <date-part name="year"/> </date> <text variable="genre" prefix=" " suffix="."/> <text variable="archive_location" prefix=" " suffix="."/> <text variable="publisher-place" prefix=" "/> </else-if> <else-if type="personal_communication"> <date variable="issued" prefix=" " suffix="."> <date-part name="day" suffix=" "/> <date-part name="month" form="short" suffix=" "/> <date-part name="year"/> </date> <choose> <if variable="genre"> <text prefix=" " suffix="." variable="genre"/> </if> <else> <text prefix=" " suffix="." value="E-mail"/> </else> </choose> </else-if> <else-if type="map"> <text variable="genre" prefix=" " suffix="."/> <text variable="publisher-place" prefix=" " suffix=":"/> <text macro="publisher" prefix=" "/> <date variable="issued" prefix=" " suffix=","> <date-part name="year"/> </date> </else-if> <else-if type="speech"> <text variable="event" prefix=" " suffix="."/> <text variable="publisher-place" prefix=" " suffix="."/> <date variable="issued" prefix=" " suffix="."> <date-part name="year"/> </date> <text variable="genre" prefix=" " suffix="."/> </else-if> <else-if type="webpage post-weblog" match="any"> <text variable="genre" prefix=" " suffix="."/> <text variable="container-title" font-style="italic" prefix=" " suffix="."/> <group delimiter=", " prefix=" "> <text macro="publisher"/> <text macro="issued-full-date" suffix="."/> </group> </else-if> <else-if type="broadcast"> <text variable="container-title" font-style="italic" prefix=" " suffix="."/> <text macro="publisher" prefix=" " suffix=","/> <date variable="issued" prefix=" " suffix="."> <date-part name="day" suffix=" "/> <date-part name="month" form="short" suffix=" " strip-periods="false"/> <date-part name="year"/> </date> </else-if> <else> <group prefix=" " suffix="." delimiter=": "> <group delimiter=" "> <text macro="editor-translator" suffix="."/> <text variable="container-title" font-style="italic"/> <choose> <if type="article-journal"> <group delimiter=" "> <group delimiter="."> <text variable="volume"/> <text variable="issue"/> </group> <date variable="issued" prefix="(" suffix="):"> <date-part name="year"/> </date> </group> <text macro="pages" prefix=" "/> </if> <else> <group> <date variable="issued"> <date-part name="day" suffix=" "/> <date-part name="month" form="short" suffix=" " strip-periods="false"/> <date-part name="year"/> </date> <choose> <if variable="URL DOI" match="any"> <text variable="page" prefix=": "/> </if> <else> <text macro="pages" prefix=": "/> </else> </choose> </group> </else> </choose> </group> </group> </else> </choose> <text macro="medium" suffix="."/> <text macro="number-of-volumes-optional" suffix="." prefix=" "/> <text macro="collection-title"/> <text macro="collection-number"/> </layout> </bibliography> </style> ';
  nature:string ='<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only" default-locale="en-GB"> <info> <title>Nature</title> <id>http://www.zotero.org/styles/nature</id> <link href="http://www.zotero.org/styles/nature" rel="self"/> <link href="http://www.nature.com/nature/authors/gta/index.html#a5.4" rel="documentation"/> <author> <name>Michael Berkowitz</name> <email>mberkowi@gmu.edu</email> </author> <category citation-format="numeric"/> <category field="science"/> <category field="generic-base"/> <issn>0028-0836</issn> <eissn>1476-4687</eissn> <updated>2014-06-22T03:46:28+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <macro name="title"> <choose> <if type="bill book graphic legal_case legislation motion_picture report song" match="any"> <text variable="title" font-style="italic"/> </if> <else-if type="chapter" match="any"/> <else> <text variable="title"/> </else> </choose> </macro> <macro name="author"> <names variable="author"> <name sort-separator=", " delimiter=", " and="symbol" initialize-with=". " delimiter-precedes-last="never" name-as-sort-order="all"/> <label form="short" prefix=", "/> <et-al font-style="italic"/> </names> </macro> <macro name="access"> <choose> <if variable="volume"/> <else-if variable="DOI"> <text variable="DOI" prefix="doi:"/> </else-if> <else-if variable="URL"> <text term="at"/> <text variable="URL" prefix=" &lt;" suffix="&gt;"/> </else-if> </choose> </macro> <macro name="issuance"> <choose> <if type="bill book graphic legal_case legislation motion_picture report song thesis chapter paper-conference" match="any"> <group delimiter=", " prefix="(" suffix=")."> <text variable="publisher" form="long"/> <date variable="issued"> <date-part name="year"/> </date> </group> </if> <else> <date prefix="(" suffix=")." variable="issued"> <date-part name="year"/> </date> </else> </choose> </macro> <macro name="container-title"> <choose> <if type="article-journal"> <text variable="container-title" font-style="italic" form="short"/> </if> <else> <text variable="container-title" font-style="italic"/> </else> </choose> </macro> <macro name="editor"> <choose> <if type="chapter paper-conference" match="any"> <names variable="editor" prefix="(" suffix=")"> <label form="short" suffix=" "/> <name and="symbol" delimiter-precedes-last="never" initialize-with=". " name-as-sort-order="all"/> </names> </if> </choose> </macro> <citation collapse="citation-number"> <sort> <key variable="citation-number"/> </sort> <layout vertical-align="sup" delimiter=","> <text variable="citation-number"/> </layout> </citation> <bibliography et-al-min="6" et-al-use-first="1" second-field-align="flush" entry-spacing="0" line-spacing="2"> <layout> <text variable="citation-number" suffix="."/> <group delimiter=" "> <text macro="author" suffix="."/> <text macro="title" suffix="."/> <choose> <if type="chapter paper-conference" match="any"> <text term="in" form="long" plural="false"/> </if> </choose> <text macro="container-title"/> <text macro="editor"/> <group font-weight="bold"> <text variable="volume" suffix=","/> </group> <text variable="page"/> <text macro="issuance"/> <text macro="access"/> </group> </layout> </bibliography> </style> ';
//nature_csl:string ='<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only" default-locale="en-GB"> <info> <title>Nature</title> <id>http://www.zotero.org/styles/nature</id> <link href="http://www.zotero.org/styles/nature" rel="self"/> <link href="http://www.nature.com/nature/authors/gta/index.html#a5.4" rel="documentation"/> <author> <name>Michael Berkowitz</name> <email>mberkowi@gmu.edu</email> </author> <category citation-format="numeric"/> <category field="science"/> <category field="generic-base"/> <issn>0028-0836</issn> <eissn>1476-4687</eissn> <updated>2016-03-10T03:00:48+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <macro name="title"> <choose> <if type="bill book graphic legal_case legislation motion_picture report song" match="any"> <text variable="title" font-style="italic"/> </if> <else-if type="chapter" match="any"/> <else> <text variable="title"/> </else> </choose> </macro> <macro name="author"> <names variable="author"> <name sort-separator=", " delimiter=", " and="symbol" initialize-with=". " delimiter-precedes-last="never" name-as-sort-order="all"/> <label form="short" prefix=", "/> <et-al font-style="italic"/> </names> </macro> <macro name="access"> <choose> <if variable="volume"/> <else-if variable="DOI"> <text variable="DOI" prefix="doi:"/> </else-if> <else-if type="webpage" variable="URL" match="all"> <text term="available at" text-case="capitalize-first" suffix=": "/> <text variable="URL" suffix=". "/> <group prefix="(" suffix=")" delimiter=": "> <text term="accessed" text-case="capitalize-first"/> <date variable="accessed"> <date-part name="day" suffix=" " form="ordinal"/> <date-part name="month" suffix=" "/> <date-part name="year"/> </date> </group> </else-if> </choose> </macro> <macro name="issuance"> <choose> <if type="bill book graphic legal_case legislation motion_picture report song thesis chapter paper-conference" match="any"> <group delimiter=", " prefix="(" suffix=")."> <text variable="publisher" form="long"/> <date variable="issued"> <date-part name="year"/> </date> </group> </if> <else> <date prefix="(" suffix=")." variable="issued"> <date-part name="year"/> </date> </else> </choose> </macro> <macro name="container-title"> <choose> <if type="article-journal"> <text variable="container-title" font-style="italic" form="short"/> </if> <else> <text variable="container-title" font-style="italic"/> </else> </choose> </macro> <macro name="editor"> <choose> <if type="chapter paper-conference" match="any"> <names variable="editor" prefix="(" suffix=")"> <label form="short" suffix=" "/> <name and="symbol" delimiter-precedes-last="never" initialize-with=". " name-as-sort-order="all"/> </names> </if> </choose> </macro> <citation collapse="citation-number"> <sort> <key variable="citation-number"/> </sort> <layout vertical-align="sup" delimiter=","> <text variable="citation-number"/> </layout> </citation> <bibliography et-al-min="6" et-al-use-first="1" second-field-align="flush" entry-spacing="0" line-spacing="2"> <layout> <text variable="citation-number" suffix="."/> <group delimiter=" "> <text macro="author" suffix="."/> <text macro="title" suffix="."/> <choose> <if type="chapter paper-conference" match="any"> <text term="in" form="long" plural="false"/> </if> </choose> <text macro="container-title"/> <text macro="editor"/> <group font-weight="bold"> <text variable="volume" suffix=","/> </group> <text variable="page"/> <text macro="issuance"/> <text macro="access"/> </group> </layout> </bibliography> </style>';
  acm:string ='<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only" default-locale="en-US"> <info> <title>ACM SIG Proceedings ("et al." for 3+ authors)</title> <id>http://www.zotero.org/styles/acm-sig-proceedings</id> <link href="http://www.zotero.org/styles/acm-sig-proceedings" rel="self"/> <link href="http://www.acm.org/sigs/publications/proceedings-templates" rel="documentation"/> <author> <name>Naeem Esfahani</name> <email>nesfaha2@gmu.edu</email> <uri>http://mason.gmu.edu/~nesfaha2/</uri> </author> <contributor> <name>Chris Horn</name> <email>chris.horn@securedecisions.com</email> </contributor> <category citation-format="numeric"/> <category field="science"/> <category field="engineering"/> <updated>2012-09-27T22:06:38+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <macro name="author"> <choose> <if type="webpage"> <text variable="title" suffix=":"/> </if> <else> <names variable="author"> <name name-as-sort-order="all" and="text" sort-separator=", " initialize-with="." delimiter-precedes-last="never" delimiter=", "/> <label form="short" prefix=" "/> <substitute> <names variable="editor"/> <names variable="translator"/> </substitute> </names> </else> </choose> </macro> <macro name="editor"> <names variable="editor"> <name initialize-with="." delimiter=", " and="text"/> <label form="short" prefix=", "/> </names> </macro> <citation collapse="citation-number"> <sort> <key variable="citation-number"/> </sort> <layout prefix="[" suffix="]" delimiter=", "> <text variable="citation-number"/> </layout> </citation> <bibliography entry-spacing="0" second-field-align="flush" et-al-min="3" et-al-use-first="1"> <sort> <key macro="author"/> <key variable="title"/> </sort> <layout suffix="."> <text variable="citation-number" prefix="[" suffix="]"/> <text macro="author" suffix=" "/> <date variable="issued" suffix=". "> <date-part name="year"/> </date> <choose> <if type="paper-conference"> <group delimiter=". "> <text variable="title"/> <group delimiter=" "> <text variable="container-title" font-style="italic"/> <group delimiter=", "> <group delimiter=", " prefix="(" suffix=")"> <text variable="publisher-place"/> <date variable="issued"> <date-part name="month" form="short" suffix=" "/> <date-part name="year"/> </date> </group> <text variable="page"/> </group> </group> </group> </if> <else-if type="article-journal"> <group delimiter=". "> <text variable="title"/> <text variable="container-title" font-style="italic"/> <group delimiter=", "> <text variable="volume"/> <group delimiter=" "> <text variable="issue"/> <date variable="issued" prefix="(" suffix=")"> <date-part name="month" form="short" suffix=" "/> <date-part name="year"/> </date> </group> <text variable="page"/> </group> </group> </else-if> <else-if type="patent"> <group delimiter=". "> <text variable="title"/> <text variable="number"/> <date variable="issued"> <date-part name="month" form="short" suffix=" "/> <date-part name="day" suffix=", "/> <date-part name="year"/> </date> </group> </else-if> <else-if type="thesis"> <group delimiter=". "> <text variable="title" font-style="italic"/> <text variable="archive_location" prefix="Doctoral Thesis #"/> <text variable="publisher"/> </group> </else-if> <else-if type="report"> <group delimiter=". "> <text variable="title" font-style="italic"/> <text variable="number" prefix="Technical Report #"/> <text variable="publisher"/> </group> </else-if> <else-if type="webpage"> <group delimiter=". "> <text variable="URL" font-style="italic"/> <date variable="accessed" prefix="Accessed: "> <date-part name="year" suffix="-"/> <date-part name="month" form="numeric-leading-zeros" suffix="-"/> <date-part name="day" form="numeric-leading-zeros"/> </date> </group> </else-if> <else-if type="chapter paper-conference" match="any"> <group delimiter=". "> <text variable="title"/> <text variable="container-title" font-style="italic"/> <text macro="editor"/> <text variable="publisher"/> <text variable="page"/> </group> </else-if> <else-if type="bill book graphic legal_case legislation motion_picture report song" match="any"> <group delimiter=". "> <text variable="title" font-style="italic"/> <text variable="publisher"/> </group> </else-if> <else> <group delimiter=". "> <text variable="title"/> <text variable="container-title" font-style="italic"/> <text variable="publisher"/> </group> </else> </choose> </layout> </bibliography> </style> ';
  apa:string ='<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="never" page-range-format="expanded"> <info> <title>American Psychological Association 6th edition</title> <title-short>APA</title-short> <id>http://www.zotero.org/styles/apa</id> <link href="http://www.zotero.org/styles/apa" rel="self"/> <link href="http://owl.english.purdue.edu/owl/resource/560/01/" rel="documentation"/> <author> <name>Simon Kornblith</name> <email>simon@simonster.com</email> </author> <contributor> <name>Bruce DArcus</name> </contributor> <contributor> <name>Curtis M. Humphrey</name> </contributor> <contributor> <name>Richard Karnesky</name> <email>karnesky+zotero@gmail.com</email> <uri>http://arc.nucapt.northwestern.edu/Richard_Karnesky</uri> </contributor> <contributor> <name>Sebastian Karcher</name> </contributor> <contributor> <name> Brenton M. Wiernik</name> <email>zotero@wiernik.org</email> </contributor> <category citation-format="author-date"/> <category field="psychology"/> <category field="generic-base"/> <updated>2016-09-28T13:09:49+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <locale xml:lang="en"> <terms> <term name="editortranslator" form="short"> <single>ed. &amp; trans.</single> <multiple>eds. &amp; trans.</multiple> </term> <term name="translator" form="short"> <single>trans.</single> <multiple>trans.</multiple> </term> </terms> </locale> <macro name="container-contributors"> <choose> <if type="chapter paper-conference entry-dictionary entry-encyclopedia" match="any"> <group delimiter=", "> <names variable="container-author" delimiter=", "> <name and="symbol" initialize-with=". " delimiter=", "/> <label form="short" prefix=" (" text-case="title" suffix=")"/> </names> <names variable="editor translator" delimiter=", "> <name and="symbol" initialize-with=". " delimiter=", "/> <label form="short" prefix=" (" text-case="title" suffix=")"/> </names> </group> </if> </choose> </macro> <macro name="secondary-contributors"> <choose> <if type="article-journal chapter paper-conference entry-dictionary entry-encyclopedia" match="none"> <group delimiter=", " prefix=" (" suffix=")"> <names variable="container-author" delimiter=", "> <name and="symbol" initialize-with=". " delimiter=", "/> <label form="short" prefix=", " text-case="title"/> </names> <names variable="editor translator" delimiter=", "> <name and="symbol" initialize-with=". " delimiter=", "/> <label form="short" prefix=", " text-case="title"/> </names> </group> </if> </choose> </macro> <macro name="author"> <names variable="author"> <name name-as-sort-order="all" and="symbol" sort-separator=", " initialize-with=". " delimiter=", " delimiter-precedes-last="always"/> <label form="short" prefix=" (" suffix=")" text-case="capitalize-first"/> <substitute> <names variable="editor"/> <names variable="translator"/> <choose> <if type="report"> <text variable="publisher"/> <text macro="title"/> </if> <else> <text macro="title"/> </else> </choose> </substitute> </names> </macro> <macro name="author-short"> <choose> <if type="patent" variable="number" match="all"> <text macro="patent-number"/> </if> <else> <names variable="author"> <name form="short" and="symbol" delimiter=", " initialize-with=". "/> <substitute> <names variable="editor"/> <names variable="translator"/> <choose> <if type="report"> <text variable="publisher"/> <text variable="title" form="short" font-style="italic"/> </if> <else-if type="legal_case"> <text variable="title" font-style="italic"/> </else-if> <else-if type="book graphic motion_picture song" match="any"> <text variable="title" form="short" font-style="italic"/> </else-if> <else-if type="bill legislation" match="any"> <text variable="title" form="short"/> </else-if> <else-if variable="reviewed-author"> <choose> <if variable="reviewed-title" match="none"> <text variable="title" form="short" font-style="italic" prefix="Review of "/> </if> <else> <text variable="title" form="short" quotes="true"/> </else> </choose> </else-if> <else> <text variable="title" form="short" quotes="true"/> </else> </choose> </substitute> </names> </else> </choose> </macro> <macro name="patent-number"> <!-- genre: U.S. Patent number: 123,445--> <group delimiter=" "> <group delimiter=" "> <text variable="genre"/> <text term="issue" form="short" text-case="capitalize-first"/> </group> <text variable="number"/> </group> </macro> <macro name="access"> <choose> <if type="thesis report" match="any"> <choose> <if variable="DOI" match="any"> <text variable="DOI" prefix="https://doi.org/"/> </if> <else-if variable="URL" match="any"> <group> <text term="retrieved" text-case="capitalize-first" suffix=" "/> <text term="from" suffix=" "/> <text variable="URL"/> </group> </else-if> <else-if variable="archive" match="any"> <group> <text term="retrieved" text-case="capitalize-first" suffix=" "/> <text term="from" suffix=" "/> <text variable="archive" suffix="."/> <text variable="archive_location" prefix=" (" suffix=")"/> </group> </else-if> </choose> </if> <else> <choose> <if variable="DOI"> <text variable="DOI" prefix="https://doi.org/"/> </if> <else> <choose> <if type="post post-weblog webpage" match="any"> <group delimiter=" "> <text term="retrieved" text-case="capitalize-first" suffix=" "/> <group> <date variable="accessed" form="text" suffix=", "/> </group> <text term="from"/> <text variable="URL"/> </group> </if> <else> <group> <text term="retrieved" text-case="capitalize-first" suffix=" "/> <text term="from" suffix=" "/> <text variable="URL"/> </group> </else> </choose> </else> </choose> </else> </choose> </macro> <macro name="title"> <choose> <if type="book dataset graphic manuscript motion_picture report song speech thesis" match="any"> <choose> <if variable="version" type="book" match="all"> <!---This is a hack until we have a computer program type --> <text variable="title"/> </if> <else> <text variable="title" font-style="italic"/> </else> </choose> </if> <else-if variable="reviewed-author"> <choose> <if variable="reviewed-title"> <group delimiter=" "> <text variable="title"/> <group delimiter=", " prefix="[" suffix="]"> <text variable="reviewed-title" font-style="italic" prefix="Review of "/> <names variable="reviewed-author" delimiter=", "> <label form="verb-short" suffix=" "/> <name and="symbol" initialize-with=". " delimiter=", "/> </names> </group> </group> </if> <else> <!-- assume `title` is title of reviewed work --> <group delimiter=", " prefix="[" suffix="]"> <text variable="title" font-style="italic" prefix="Review of "/> <names variable="reviewed-author" delimiter=", "> <label form="verb-short" suffix=" "/> <name and="symbol" initialize-with=". " delimiter=", "/> </names> </group> </else> </choose> </else-if> <else-if type="patent" variable="number" match="all"> <text macro="patent-number" font-style="italic"/> </else-if> <else> <text variable="title"/> </else> </choose> </macro> <macro name="title-plus-extra"> <text macro="title"/> <choose> <if type="report thesis" match="any"> <group prefix=" (" suffix=")" delimiter=", "> <group delimiter=" "> <choose> <if variable="genre" match="any"> <text variable="genre"/> </if> <else> <text variable="collection-title"/> </else> </choose> <text variable="number" prefix="No. "/> </group> <group delimiter=" "> <text term="version" text-case="capitalize-first"/> <text variable="version"/> </group> <text macro="edition"/> </group> </if> <else-if type="post-weblog webpage" match="any"> <text variable="genre" prefix=" [" suffix="]"/> </else-if> <else-if variable="version"> <group delimiter=" " prefix=" (" suffix=")"> <text term="version" text-case="capitalize-first"/> <text variable="version"/> </group> </else-if> </choose> <text macro="format" prefix=" [" suffix="]"/> </macro> <macro name="format"> <choose> <if match="any" variable="medium"> <text variable="medium" text-case="capitalize-first"/> </if> <else-if type="dataset" match="any"> <choose> <if variable="genre"> <text variable="genre" text-case="capitalize-first"/> </if> <else> <!-- This should be localized --> <text value="Data set"/> </else> </choose> </else-if> </choose> </macro> <macro name="publisher"> <choose> <if type="report" match="any"> <group delimiter=": "> <text variable="publisher-place"/> <text variable="publisher"/> </group> </if> <else-if type="thesis" match="any"> <group delimiter=", "> <text variable="publisher"/> <text variable="publisher-place"/> </group> </else-if> <else-if type="patent"> <group delimiter=": "> <text variable="publisher-place"/> <choose> <if variable="publisher"> <text variable="publisher"/> </if> <else> <text variable="authority"/> </else> </choose> </group> </else-if> <else-if type="post-weblog webpage" match="none"> <group delimiter=", "> <choose> <if variable="event version" type="speech dataset motion_picture" match="none"> <!-- Including version is to avoid printing the programming language for computerProgram /--> <text variable="genre"/> </if> </choose> <choose> <if type="article-journal article-magazine article-newspaper" match="none"> <group delimiter=": "> <choose> <if variable="publisher-place"> <text variable="publisher-place"/> </if> <else> <text variable="event-place"/> </else> </choose> <text variable="publisher"/> </group> </if> </choose> </group> </else-if> </choose> </macro> <macro name="event"> <choose> <if variable="container-title" match="none"> <choose> <if variable="event"> <choose> <if variable="genre" match="none"> <text term="presented at" text-case="capitalize-first" suffix=" "/> <text variable="event"/> </if> <else> <group delimiter=" "> <text variable="genre" text-case="capitalize-first"/> <text term="presented at"/> <text variable="event"/> </group> </else> </choose> </if> <else-if type="speech"> <text variable="genre" text-case="capitalize-first"/> </else-if> </choose> </if> </choose> </macro> <macro name="issued"> <choose> <if type="bill legal_case legislation" match="none"> <choose> <if variable="issued"> <group prefix=" (" suffix=")"> <date variable="issued"> <date-part name="year"/> </date> <text variable="year-suffix"/> <choose> <if type="speech" match="any"> <date variable="issued"> <date-part prefix=", " name="month"/> </date> </if> <else-if type="article-journal bill book chapter graphic legal_case legislation motion_picture paper-conference report song dataset" match="none"> <date variable="issued"> <date-part prefix=", " name="month"/> <date-part prefix=" " name="day"/> </date> </else-if> </choose> </group> </if> <else-if variable="status"> <group prefix=" (" suffix=")"> <text variable="status"/> <text variable="year-suffix" prefix="-"/> </group> </else-if> <else> <group prefix=" (" suffix=")"> <text term="no date" form="short"/> <text variable="year-suffix" prefix="-"/> </group> </else> </choose> </if> </choose> </macro> <macro name="issued-sort"> <choose> <if type="article-journal bill book chapter graphic legal_case legislation motion_picture paper-conference report song dataset" match="none"> <date variable="issued"> <date-part name="year"/> <date-part name="month"/> <date-part name="day"/> </date> </if> <else> <date variable="issued"> <date-part name="year"/> </date> </else> </choose> </macro> <macro name="issued-year"> <choose> <if variable="issued"> <group delimiter="/"> <date variable="original-date"> <date-part name="year"/> </date> <group> <date variable="issued"> <date-part name="year"/> </date> <text variable="year-suffix"/> </group> </group> </if> <else-if variable="status"> <text variable="status"/> <text variable="year-suffix" prefix="-"/> </else-if> <else> <text term="no date" form="short"/> <text variable="year-suffix" prefix="-"/> </else> </choose> </macro> <macro name="edition"> <choose> <if is-numeric="edition"> <group delimiter=" "> <number variable="edition" form="ordinal"/> <text term="edition" form="short"/> </group> </if> <else> <text variable="edition"/> </else> </choose> </macro> <macro name="locators"> <choose> <if type="article-journal article-magazine" match="any"> <group prefix=", " delimiter=", "> <group> <text variable="volume" font-style="italic"/> <text variable="issue" prefix="(" suffix=")"/> </group> <text variable="page"/> </group> <choose> <!--for advanced online publication--> <if variable="issued"> <choose> <if variable="page issue" match="none"> <text variable="status" prefix=". "/> </if> </choose> </if> </choose> </if> <else-if type="article-newspaper"> <group delimiter=" " prefix=", "> <label variable="page" form="short"/> <text variable="page"/> </group> </else-if> <else-if type="book graphic motion_picture report song chapter paper-conference entry-encyclopedia entry-dictionary" match="any"> <group prefix=" (" suffix=")" delimiter=", "> <choose> <if type="report" match="none"> <!-- edition for report is included in title-plus-extra /--> <text macro="edition"/> </if> </choose> <choose> <if variable="volume" match="any"> <group> <text term="volume" form="short" text-case="capitalize-first" suffix=" "/> <number variable="volume" form="numeric"/> </group> </if> <else> <group> <text term="volume" form="short" plural="true" text-case="capitalize-first" suffix=" "/> <number variable="number-of-volumes" form="numeric" prefix="1&#8211;"/> </group> </else> </choose> <group> <label variable="page" form="short" suffix=" "/> <text variable="page"/> </group> </group> </else-if> <else-if type="legal_case"> <group prefix=" (" suffix=")" delimiter=" "> <text variable="authority"/> <choose> <if variable="container-title" match="any"> <!--Only print year for cases published in reporters--> <date variable="issued" form="numeric" date-parts="year"/> </if> <else> <date variable="issued" form="text"/> </else> </choose> </group> </else-if> <else-if type="bill legislation" match="any"> <date variable="issued" prefix=" (" suffix=")"> <date-part name="year"/> </date> </else-if> </choose> </macro> <macro name="citation-locator"> <group> <choose> <if locator="chapter"> <label variable="locator" form="long" text-case="capitalize-first"/> </if> <else> <label variable="locator" form="short"/> </else> </choose> <text variable="locator" prefix=" "/> </group> </macro> <macro name="container"> <choose> <if type="post-weblog webpage" match="none"> <group> <choose> <if type="chapter paper-conference entry-encyclopedia" match="any"> <text term="in" text-case="capitalize-first" suffix=" "/> </if> </choose> <group delimiter=", "> <text macro="container-contributors"/> <text macro="secondary-contributors"/> <text macro="container-title"/> </group> </group> </if> </choose> </macro> <macro name="container-title"> <choose> <if type="article article-journal article-magazine article-newspaper" match="any"> <text variable="container-title" font-style="italic" text-case="title"/> </if> <else-if type="bill legal_case legislation" match="none"> <text variable="container-title" font-style="italic"/> </else-if> </choose> </macro> <macro name="legal-cites"> <choose> <if type="legal_case" match="any"> <group prefix=", " delimiter=" "> <choose> <if variable="container-title"> <text variable="volume"/> <text variable="container-title"/> <group delimiter=" "> <!--change to label variable="section" as that becomes available --> <text term="section" form="symbol"/> <text variable="section"/> </group> <text variable="page"/> </if> <else> <text variable="number" prefix="No. "/> </else> </choose> </group> </if> <else-if type="bill legislation" match="any"> <group delimiter=", " prefix=", "> <choose> <if variable="number"> <!--Theres a public law number--> <text variable="number" prefix="Pub. L. No. "/> <group delimiter=" "> <!--change to label variable="section" as that becomes available --> <text term="section" form="symbol"/> <text variable="section"/> </group> <group delimiter=" "> <text variable="volume"/> <text variable="container-title"/> <text variable="page-first"/> </group> </if> <else> <group delimiter=" "> <text variable="volume"/> <text variable="container-title"/> <!--change to label variable="section" as that becomes available --> <text term="section" form="symbol"/> <text variable="section"/> </group> </else> </choose> </group> </else-if> </choose> </macro> <macro name="original-date"> <choose> <if type="bill legal_case legislation" match="none"> <choose> <if variable="original-date"> <group prefix=" (" suffix=")" delimiter=" "> <!---This should be localized--> <text value="Original work published"/> <choose> <if type="speech" match="any"> <date variable="original-date" delimiter=" "> <date-part name="month"/> <date-part name="year"/> </date> </if> <else-if type="article-journal bill book chapter graphic legal_case legislation motion_picture paper-conference report song dataset" match="none"> <date variable="original-date" form="text"/> </else-if> <else> <date variable="original-date"> <date-part name="year"/> </date> </else> </choose> </group> </if> </choose> </if> </choose> </macro> <citation et-al-min="6" et-al-use-first="1" et-al-subsequent-min="3" et-al-subsequent-use-first="1" disambiguate-add-year-suffix="true" disambiguate-add-names="true" disambiguate-add-givenname="true" collapse="year" givenname-disambiguation-rule="primary-name"> <sort> <key macro="author"/> <key macro="issued-sort"/> </sort> <layout prefix="(" suffix=")" delimiter="; "> <group delimiter=", "> <text macro="author-short"/> <text macro="issued-year"/> <text macro="citation-locator"/> </group> </layout> </citation> <bibliography hanging-indent="true" et-al-min="8" et-al-use-first="6" et-al-use-last="true" entry-spacing="0" line-spacing="2"> <sort> <key macro="author"/> <key macro="issued-sort" sort="ascending"/> <key macro="title"/> </sort> <layout> <group suffix="."> <group delimiter=". "> <text macro="author"/> <text macro="issued"/> <text macro="title-plus-extra"/> <text macro="container"/> </group> <text macro="legal-cites"/> <text macro="locators"/> <group delimiter=", " prefix=". "> <text macro="event"/> <text macro="publisher"/> </group> </group> <text macro="access" prefix=" "/> <text macro="original-date" prefix=" "/> </layout> </bibliography> </style>`';
  // is short version
  harvard:string = '<?xml version="1.0" encoding="utf-8"?> <style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only"> <info> <title>Harvard Reference format 1 (author-date)</title> <id>http://www.zotero.org/styles/harvard1</id> <link href="http://www.zotero.org/styles/harvard1" rel="self"/> <link href="http://libweb.anglia.ac.uk/referencing/harvard.htm" rel="documentation"/> <author> <name>Julian Onions</name> <email>julian.onions@gmail.com</email> </author> <category citation-format="author-date"/> <category field="generic-base"/> <summary>The Harvard author-date style</summary> <updated>2012-09-27T22:06:38+00:00</updated> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> </info> <macro name="editor"> <names variable="editor" delimiter=", "> <name and="symbol" initialize-with=". " delimiter=", "/> <label form="short" prefix=", " text-case="lowercase"/> </names> </macro> <macro name="anon"> <text term="anonymous" form="short" text-case="capitalize-first" strip-periods="true"/> </macro> <macro name="author"> <names variable="author"> <name name-as-sort-order="all" and="symbol" sort-separator=", " initialize-with="." delimiter-precedes-last="never" delimiter=", "/> <label form="short" prefix=" " text-case="lowercase"/> <substitute> <names variable="editor"/> <text macro="anon"/> </substitute> </names> </macro> <macro name="author-short"> <names variable="author"> <name form="short" and="symbol" delimiter=", " delimiter-precedes-last="never" initialize-with=". "/> <substitute> <names variable="editor"/> <names variable="translator"/> <text macro="anon"/> </substitute> </names> </macro> <macro name="access"> <choose> <if variable="URL"> <text value="Available at:" suffix=" "/> <text variable="URL"/> <group prefix=" [" suffix="]"> <text term="accessed" text-case="capitalize-first" suffix=" "/> <date variable="accessed"> <date-part name="month" suffix=" "/> <date-part name="day" suffix=", "/> <date-part name="year"/> </date> </group> </if> </choose> </macro> <macro name="title"> <choose> <if type="bill book graphic legal_case legislation motion_picture report song thesis" match="any"> <text variable="title" font-style="italic"/> </if> <else> <text variable="title"/> </else> </choose> </macro> <macro name="publisher"> <group delimiter=": "> <text variable="publisher-place"/> <text variable="publisher"/> </group> </macro> <macro name="year-date"> <choose> <if variable="issued"> <date variable="issued"> <date-part name="year"/> </date> </if> <else> <text term="no date" form="short"/> </else> </choose> </macro> <macro name="edition"> <choose> <if is-numeric="edition"> <group delimiter=" "> <number variable="edition" form="ordinal"/> <text term="edition" form="short"/> </group> </if> <else> <text variable="edition" suffix="."/> </else> </choose> </macro> <macro name="pages"> <group> <label variable="page" form="short" suffix=" "/> <text variable="page"/> </group> </macro> <citation et-al-min="3" et-al-use-first="1" disambiguate-add-year-suffix="true" disambiguate-add-names="true" disambiguate-add-givenname="true"> <layout prefix="(" suffix=")" delimiter="; "> <group delimiter=", "> <group delimiter=" "> <text macro="author-short"/> <text macro="year-date"/> </group> <group> <label variable="locator" form="short"/> <text variable="locator"/> </group> </group> </layout> </citation> <bibliography hanging-indent="true" et-al-min="4" et-al-use-first="1"> <sort> <key macro="author"/> <key variable="title"/> </sort> <layout> <text macro="author" suffix=","/> <date variable="issued" prefix=" " suffix="."> <date-part name="year"/> </date> <choose> <if type="bill book graphic legal_case legislation motion_picture report song" match="any"> <group prefix=" " delimiter=" " suffix=","> <text macro="title"/> <text macro="edition"/> <text macro="editor"/> </group> <text prefix=" " suffix="." macro="publisher"/> </if> <else-if type="chapter paper-conference" match="any"> <text macro="title" prefix=" " suffix="."/> <group prefix=" " delimiter=" "> <text term="in" text-case="capitalize-first"/> <text macro="editor"/> <text variable="container-title" font-style="italic" suffix="."/> <text variable="collection-title" suffix="."/> <text variable="event" suffix="."/> <group suffix="." delimiter=", "> <text macro="publisher" prefix=" "/> <text macro="pages"/> </group> </group> </else-if> <else-if type="thesis"> <group prefix=" " suffix="." delimiter=". "> <text macro="title"/> <text variable="genre"/> <text macro="publisher"/> </group> </else-if> <else> <group suffix="."> <text macro="title" prefix=" "/> <text macro="editor" prefix=" "/> </group> <group prefix=" " suffix="."> <text variable="container-title" font-style="italic"/> <group prefix=", "> <text variable="volume"/> <text variable="issue" prefix="(" suffix=")"/> </group> <group prefix=", "> <label variable="page" form="short"/> <text variable="page"/> </group> </group> </else> </choose> <text prefix=" " macro="access" suffix="."/> </layout> </bibliography> </style>';
  locale:string ='<?xml version="1.0" encoding="utf-8"?> <locale xmlns="http://purl.org/net/xbiblio/csl" version="1.0" xml:lang="en-US"> <info> <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights> <updated>2012-07-04T23:31:02+00:00</updated> </info> <style-options punctuation-in-quote="true" leading-noise-words="a,an,the" name-as-sort-order="ja zh kr my hu vi" name-never-short="ja zh kr my hu vi"/> <date form="text"> <date-part name="month" suffix=" "/> <date-part name="day" suffix=", "/> <date-part name="year"/> </date> <date form="numeric"> <date-part name="month" form="numeric-leading-zeros" suffix="/"/> <date-part name="day" form="numeric-leading-zeros" suffix="/"/> <date-part name="year"/> </date> <terms> <term name="radio-broadcast">radio broadcast</term> <term name="television-broadcast">television broadcast</term> <term name="podcast">podcast</term> <term name="instant-message">instant message</term> <term name="email">email</term> <term name="number-of-volumes"> <single>volume</single> <multiple>volumes</multiple> </term> <term name="accessed">accessed</term> <term name="and">and</term> <term name="and" form="symbol">&amp;</term> <term name="and others">and others</term> <term name="anonymous">anonymous</term> <term name="anonymous" form="short">anon.</term> <term name="at">at</term> <term name="available at">available at</term> <term name="by">by</term> <term name="circa">circa</term> <term name="circa" form="short">c.</term> <term name="cited">cited</term> <term name="edition"> <single>edition</single> <multiple>editions</multiple> </term> <term name="edition" form="short">ed.</term> <term name="et-al">et al.</term> <term name="forthcoming">forthcoming</term> <term name="from">from</term> <term name="ibid">ibid.</term> <term name="in">in</term> <term name="in press">in press</term> <term name="internet">internet</term> <term name="interview">interview</term> <term name="letter">letter</term> <term name="no date">no date</term> <term name="no date" form="short">n.d.</term> <term name="online">online</term> <term name="presented at">presented at the</term> <term name="reference"> <single>reference</single> <multiple>references</multiple> </term> <term name="reference" form="short"> <single>ref.</single> <multiple>refs.</multiple> </term> <term name="retrieved">retrieved</term> <term name="scale">scale</term> <term name="version">version</term> <!-- ANNO DOMINI; BEFORE CHRIST --> <term name="ad">AD</term> <term name="bc">BC</term> <!-- PUNCTUATION --> <term name="open-quote">“</term> <term name="close-quote">”</term> <term name="open-inner-quote">‘</term> <term name="close-inner-quote">’</term> <term name="page-range-delimiter">–</term> <!-- ORDINALS --> <term name="ordinal">th</term> <term name="ordinal-01">st</term> <term name="ordinal-02">nd</term> <term name="ordinal-03">rd</term> <term name="ordinal-11">th</term> <term name="ordinal-12">th</term> <term name="ordinal-13">th</term> <!-- LONG ORDINALS --> <term name="long-ordinal-01">first</term> <term name="long-ordinal-02">second</term> <term name="long-ordinal-03">third</term> <term name="long-ordinal-04">fourth</term> <term name="long-ordinal-05">fifth</term> <term name="long-ordinal-06">sixth</term> <term name="long-ordinal-07">seventh</term> <term name="long-ordinal-08">eighth</term> <term name="long-ordinal-09">ninth</term> <term name="long-ordinal-10">tenth</term> <!-- LONG LOCATOR FORMS --> <term name="book"> <single>book</single> <multiple>books</multiple> </term> <term name="chapter"> <single>chapter</single> <multiple>chapters</multiple> </term> <term name="column"> <single>column</single> <multiple>columns</multiple> </term> <term name="figure"> <single>figure</single> <multiple>figures</multiple> </term> <term name="folio"> <single>folio</single> <multiple>folios</multiple> </term> <term name="issue"> <single>number</single> <multiple>numbers</multiple> </term> <term name="line"> <single>line</single> <multiple>lines</multiple> </term> <term name="note"> <single>note</single> <multiple>notes</multiple> </term> <term name="opus"> <single>opus</single> <multiple>opera</multiple> </term> <term name="page"> <single>page</single> <multiple>pages</multiple> </term> <term name="paragraph"> <single>paragraph</single> <multiple>paragraph</multiple> </term> <term name="part"> <single>part</single> <multiple>parts</multiple> </term> <term name="section"> <single>section</single> <multiple>sections</multiple> </term> <term name="subscriptions verbo"> <single>subscriptions verbo</single> <multiple>subscriptions verbis</multiple> </term> <term name="verse"> <single>verse</single> <multiple>verses</multiple> </term> <term name="volume"> <single>volume</single> <multiple>volumes</multiple> </term> <!-- SHORT LOCATOR FORMS --> <term name="book" form="short">bk.</term> <term name="chapter" form="short">chap.</term> <term name="column" form="short">col.</term> <term name="figure" form="short">fig.</term> <term name="folio" form="short">f.</term> <term name="issue" form="short">no.</term> <term name="line" form="short">l.</term> <term name="note" form="short">n.</term> <term name="opus" form="short">op.</term> <term name="page" form="short"> <single>p.</single> <multiple>pp.</multiple> </term> <term name="paragraph" form="short">para.</term> <term name="part" form="short">pt.</term> <term name="section" form="short">sec.</term> <term name="subscriptions verbo" form="short"> <single>s.v.</single> <multiple>s.vv.</multiple> </term> <term name="verse" form="short"> <single>v.</single> <multiple>vv.</multiple> </term> <term name="volume" form="short"> <single>vol.</single> <multiple>vols.</multiple> </term> <!-- SYMBOL LOCATOR FORMS --> <term name="paragraph" form="symbol"> <single>¶</single> <multiple>¶¶</multiple> </term> <term name="section" form="symbol"> <single>§</single> <multiple>§§</multiple> </term> <!-- LONG ROLE FORMS --> <term name="director"> <single>director</single> <multiple>directors</multiple> </term> <term name="editor"> <single>editor</single> <multiple>editors</multiple> </term> <term name="editorial-director"> <single>editor</single> <multiple>editors</multiple> </term> <term name="illustrator"> <single>illustrator</single> <multiple>illustrators</multiple> </term> <term name="translator"> <single>translator</single> <multiple>translators</multiple> </term> <term name="editortranslator"> <single>editor &amp; translator</single> <multiple>editors &amp; translators</multiple> </term> <!-- SHORT ROLE FORMS --> <term name="director" form="short"> <single>dir.</single> <multiple>dirs.</multiple> </term> <term name="editor" form="short"> <single>ed.</single> <multiple>eds.</multiple> </term> <term name="editorial-director" form="short"> <single>ed.</single> <multiple>eds.</multiple> </term> <term name="illustrator" form="short"> <single>ill.</single> <multiple>ills.</multiple> </term> <term name="translator" form="short"> <single>tran.</single> <multiple>trans.</multiple> </term> <term name="editortranslator" form="short"> <single>ed. &amp; tran.</single> <multiple>eds. &amp; trans.</multiple> </term> <!-- VERB ROLE FORMS --> <term name="director" form="verb">directed by</term> <term name="editor" form="verb">edited by</term> <term name="editorial-director" form="verb">edited by</term> <term name="illustrator" form="verb">illustrated by</term> <term name="interviewer" form="verb">interview by</term> <term name="recipient" form="verb">to</term> <term name="reviewed-author" form="verb">by</term> <term name="translator" form="verb">translated by</term> <term name="editortranslator" form="verb">edited &amp; translated by</term> <!-- SHORT VERB ROLE FORMS --> <term name="container-author" form="verb-short">by</term> <term name="director" form="verb-short">dir.</term> <term name="editor" form="verb-short">ed.</term> <term name="editorial-director" form="verb-short">ed.</term> <term name="illustrator" form="verb-short">illus.</term> <term name="translator" form="verb-short">trans.</term> <term name="editortranslator" form="verb-short">ed. &amp; trans.</term> <!-- LONG MONTH FORMS --> <term name="month-01">January</term> <term name="month-02">February</term> <term name="month-03">March</term> <term name="month-04">April</term> <term name="month-05">May</term> <term name="month-06">June</term> <term name="month-07">July</term> <term name="month-08">August</term> <term name="month-09">September</term> <term name="month-10">October</term> <term name="month-11">November</term> <term name="month-12">December</term> <!-- SHORT MONTH FORMS --> <term name="month-01" form="short">Jan.</term> <term name="month-02" form="short">Feb.</term> <term name="month-03" form="short">Mar.</term> <term name="month-04" form="short">Apr.</term> <term name="month-05" form="short">May</term> <term name="month-06" form="short">Jun.</term> <term name="month-07" form="short">Jul.</term> <term name="month-08" form="short">Aug.</term> <term name="month-09" form="short">Sep.</term> <term name="month-10" form="short">Oct.</term> <term name="month-11" form="short">Nov.</term> <term name="month-12" form="short">Dec.</term> <!-- SEASONS --> <term name="season-01">Spring</term> <term name="season-02">Summer</term> <term name="season-03">Autumn</term> <term name="season-04">Winter</term> </terms> </locale>';
  frontiers:string = '<?xml version="1.0" encoding="utf-8"?><style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="never" default-locale="en-US">  <info>    <title>Frontiers journals</title>    <id>http://www.zotero.org/styles/frontiers</id>    <link href="http://www.zotero.org/styles/frontiers" rel="self"/>    <link href="http://www.frontiersin.org/about/AuthorGuidelines" rel="documentation"/>    <author>      <name>Sebastian Karcher</name>    </author>    <contributor>      <name>Julian Onions</name>      <email>julian.onions@gmail.com</email>    </contributor>    <category citation-format="author-date"/>    <category field="generic-base"/>    <summary>Style for the Open Access Frontiers in ... Journals</summary>    <updated>2012-09-27T22:06:38+00:00</updated>    <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>  </info>  <macro name="editor">    <names variable="editor" delimiter=", ">      <label form="short" prefix=", "/>      <name and="text" initialize-with=". " delimiter=", " prefix=" "/>    </names>  </macro>  <macro name="author">    <names variable="author">      <name name-as-sort-order="all" and="text" sort-separator=", " initialize-with=". " delimiter=", " delimiter-precedes-last="always"/>      <label form="short" prefix=" "/>      <substitute>        <names variable="editor"/>        <text variable="title"/>      </substitute>    </names>  </macro>  <macro name="author-short">    <names variable="author">      <name form="short" and="text" delimiter=", " initialize-with=". "/>      <substitute>        <names variable="editor"/>        <names variable="translator"/>        <text variable="title"/>      </substitute>    </names>  </macro>  <macro name="access">    <choose>      <if variable="DOI">        <text variable="DOI" prefix="doi:"/>      </if>      <else-if variable="URL">        <text value="Available at:" suffix=" "/>        <text variable="URL"/>        <group prefix=" [" suffix="]">          <text term="accessed" text-case="capitalize-first" suffix=" "/>          <date variable="accessed">            <date-part name="month" suffix=" "/>            <date-part name="day" suffix=", "/>            <date-part name="year"/>          </date>        </group>      </else-if>    </choose>  </macro>  <macro name="title">    <choose>      <if type="book">        <text variable="title" font-style="italic" suffix="."/>      </if>      <else-if type="chapter">        <text variable="title" quotes="true" suffix=","/>      </else-if>      <else>        <text variable="title" suffix="."/>      </else>    </choose>  </macro>  <macro name="publisher">    <group delimiter=": ">      <text variable="publisher-place"/>      <text variable="publisher"/>    </group>  </macro>  <macro name="year-date">    <date variable="issued">      <date-part name="year"/>    </date>  </macro>  <macro name="edition">    <choose>      <if is-numeric="edition">        <group delimiter=" ">          <number variable="edition" form="ordinal"/>          <text term="edition" form="short"/>        </group>      </if>      <else>        <text variable="edition" suffix="."/>      </else>    </choose>  </macro>  <citation et-al-min="3" et-al-use-first="1" disambiguate-add-year-suffix="true" collapse="year">    <sort>      <key macro="year-date"/>      <key macro="author-short"/>    </sort>    <layout prefix="(" suffix=")" delimiter="; ">      <group delimiter=", ">        <text macro="author-short"/>        <text macro="year-date"/>        <text variable="locator"/>      </group>    </layout>  </citation>  <bibliography hanging-indent="true" et-al-min="7" et-al-use-first="6">    <sort>      <key macro="author"/>      <key macro="year-date"/>      <key variable="title"/>    </sort>    <layout suffix=".">      <text macro="author"/>      <text macro="year-date" prefix=" (" suffix=")."/>      <choose>        <if type="bill book graphic legal_case legislation motion_picture report song" match="any">          <group delimiter=" " prefix=" ">            <text macro="title"/>            <text macro="edition"/>            <text macro="editor"/>            <text macro="publisher"/>          </group>        </if>        <else-if type="chapter paper-conference" match="any">          <group delimiter=" " prefix=" ">            <text macro="title"/>            <text term="in"/>            <text variable="container-title" font-style="italic"/>            <text variable="collection-title" suffix="."/>          </group>          <text macro="editor"/>          <group suffix=".">            <text macro="publisher" prefix=" (" suffix=")"/>            <group prefix=", ">              <text variable="page"/>            </group>          </group>        </else-if>        <else>          <text macro="title" prefix=" " suffix="."/>          <group delimiter=", " prefix=" " suffix=".">            <group delimiter=" ">              <text variable="container-title" form="short" font-style="italic"/>              <text variable="volume"/>            </group>            <text variable="page"/>          </group>        </else>      </choose>      <text prefix=" " macro="access"/>    </layout>  </bibliography></style>';
  ama:string = '<?xml version="1.0" encoding="utf-8"?><style xmlns="http://purl.org/net/xbiblio/csl" class="in-text" version="1.0" demote-non-dropping-particle="sort-only" default-locale="en-US" page-range-format="expanded">  <info>    <title>American Medical Association</title>    <title-short>AMA</title-short>    <id>http://www.zotero.org/styles/american-medical-association</id>    <link href="http://www.zotero.org/styles/american-medical-association" rel="self"/>    <link href="https://westlibrary.txwes.edu/sites/default/files/pdf/AMACitationStyle.pdf" rel="documentation"/>    <author>      <name>Julian Onions</name>      <email>julian.onions@gmail.com</email>    </author>    <contributor>      <name>Christian Pietsch</name>      <uri>http://purl.org/net/pietsch</uri>    </contributor>    <contributor>      <name>Daniel W Chan</name>      <email>danwchan@protonmail.com</email>    </contributor>    <category citation-format="numeric"/>    <category field="medicine"/>    <summary>The American Medical Association style as used in JAMA.</summary>    <updated>2018-01-18T11:17:00-05:00</updated>    <rights license="http://creativecommons.org/licenses/by-sa/3.0/">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>  </info>  <locale xml:lang="en">    <terms>      <term name="page-range-delimiter">-</term>    </terms>  </locale>  <macro name="editor">    <names variable="editor">      <name name-as-sort-order="all" sort-separator=" " initialize-with="" delimiter=", " delimiter-precedes-last="always"/>      <label form="short" prefix=", "/>    </names>  </macro>  <macro name="author">    <group suffix=".">      <names variable="author">        <name name-as-sort-order="all" sort-separator=" " initialize-with="" delimiter=", " delimiter-precedes-last="always"/>        <label form="short" prefix=", "/>        <substitute>          <names variable="editor"/>          <text macro="title"/>        </substitute>      </names>    </group>  </macro>  <macro name="access">    <choose>      <if type="article-newspaper" match="none">        <choose>          <if variable="DOI">            <text value="doi:"/>            <text variable="DOI"/>          </if>          <else-if variable="URL">            <group delimiter=". " suffix=".">              <text variable="URL"/>              <choose>                <if type="webpage">                  <date variable="issued" prefix="Published " form="text"/>                </if>              </choose>              <group>                <text term="accessed" text-case="capitalize-first" suffix=" "/>                <date variable="accessed">                  <date-part name="month" suffix=" "/>                  <date-part name="day" suffix=", "/>                  <date-part name="year"/>                </date>              </group>            </group>          </else-if>        </choose>      </if>    </choose>  </macro>  <macro name="title">    <choose>      <if type="bill book graphic legal_case legislation motion_picture report song" match="any">        <text variable="title" font-style="italic" text-case="title"/>      </if>      <else>        <text variable="title"/>      </else>    </choose>  </macro>  <macro name="publisher">    <group delimiter=": ">      <text variable="publisher-place"/>      <text variable="publisher"/>    </group>  </macro>  <macro name="edition">    <choose>      <if is-numeric="edition">        <group delimiter=" ">          <number variable="edition" form="ordinal"/>          <text term="edition" form="short"/>        </group>      </if>      <else>        <text variable="edition" suffix="."/>      </else>    </choose>  </macro>  <citation collapse="citation-number">    <sort>      <key variable="citation-number"/>    </sort>    <layout delimiter="," vertical-align="sup">      <text variable="citation-number"/>      <group prefix="(" suffix=")">        <label variable="locator" form="short" strip-periods="true"/>        <text variable="locator"/>      </group>    </layout>  </citation>  <bibliography hanging-indent="false" et-al-min="7" et-al-use-first="3" second-field-align="flush">    <layout>      <text variable="citation-number" suffix=". "/>      <text macro="author"/>      <text macro="title" prefix=" " suffix="."/>      <choose>        <if type="bill book graphic legislation motion_picture report song" match="any">          <group suffix="." prefix=" " delimiter=" ">            <group delimiter=" ">              <text term="volume" form="short" text-case="capitalize-first" strip-periods="true"/>              <text variable="volume" suffix="."/>            </group>            <text macro="edition"/>            <text macro="editor" prefix="(" suffix=")"/>          </group>          <text macro="publisher" prefix=" "/>          <group suffix="." prefix="; ">            <date variable="issued">              <date-part name="year"/>            </date>            <text variable="page" prefix=":"/>          </group>        </if>        <else-if type="chapter paper-conference entry-dictionary entry-encyclopedia" match="any">          <group prefix=" " delimiter=" ">            <text term="in" text-case="capitalize-first" suffix=":"/>            <text macro="editor"/>            <text variable="container-title" font-style="italic" suffix="." text-case="title"/>            <group delimiter=" ">              <text term="volume" form="short" text-case="capitalize-first" strip-periods="true"/>              <text variable="volume" suffix="."/>            </group>            <text macro="edition"/>            <text variable="collection-title" suffix="."/>            <group suffix=".">              <text macro="publisher"/>              <group suffix="." prefix="; ">                <date variable="issued">                  <date-part name="year"/>                </date>                <text variable="page" prefix=":"/>              </group>            </group>          </group>        </else-if>        <else-if type="article-newspaper">          <text variable="container-title" font-style="italic" prefix=" " suffix=". "/>          <choose>            <if variable="URL">              <group delimiter=". " suffix=".">                <text variable="URL"/>                <group prefix="Published ">                  <date variable="issued">                    <date-part name="month" suffix=" "/>                    <date-part name="day" suffix=", "/>                    <date-part name="year"/>                  </date>                </group>                <group>                  <text term="accessed" text-case="capitalize-first" suffix=" "/>                  <date variable="accessed">                    <date-part name="month" suffix=" "/>                    <date-part name="day" suffix=", "/>                    <date-part name="year"/>                  </date>                </group>              </group>            </if>            <else>              <group delimiter=":" suffix=".">                <group>                  <date variable="issued">                    <date-part name="month" suffix=" "/>                    <date-part name="day" suffix=", "/>                    <date-part name="year"/>                  </date>                </group>                <text variable="page"/>              </group>            </else>          </choose>        </else-if>        <else-if type="legal_case">          <group suffix="," prefix=" " delimiter=" ">            <text macro="editor" prefix="(" suffix=")"/>          </group>          <group prefix=" " delimiter=" ">            <text variable="container-title"/>            <text variable="volume"/>          </group>          <text variable="page" prefix=", " suffix=" "/>          <group prefix="(" suffix=")." delimiter=" ">            <text variable="authority"/>            <date variable="issued">              <date-part name="year"/>            </date>          </group>        </else-if>        <else-if type="webpage">          <text variable="container-title" prefix=" " suffix="."/>        </else-if>        <else-if type="speech">          <group prefix=" " suffix=":">            <choose>              <if variable="genre">                <text variable="genre" suffix=" "/>                <text term="presented at"/>              </if>              <else>                <text term="presented at" text-case="capitalize-first"/>              </else>            </choose>          </group>          <group delimiter="; " prefix=" " suffix=".">            <text variable="event"/>            <group>              <date delimiter=" " variable="issued">                <date-part name="month"/>                <date-part name="day" suffix=","/>                <date-part name="year"/>              </date>            </group>            <text variable="event-place"/>          </group>        </else-if>        <else>          <text macro="editor" prefix=" " suffix="."/>          <group prefix=" " suffix=".">            <text variable="container-title" font-style="italic" form="short" strip-periods="true" suffix="."/>            <group delimiter=";" prefix=" ">              <choose>                <if variable="issue volume" match="any">                  <date variable="issued">                    <date-part name="year"/>                  </date>                </if>                <else>                  <date variable="issued">                    <date-part name="month" suffix=" "/>                    <date-part name="year"/>                  </date>                </else>              </choose>              <group>                <text variable="volume"/>                <text variable="issue" prefix="(" suffix=")"/>              </group>            </group>            <text variable="page" prefix=":"/>          </group>        </else>      </choose>      <text prefix=" " macro="access"/>    </layout>  </bibliography></style>';
}
export class CitationData{
  public id:string;
  public type:string;
  public title:string;
  public DOI:string;
  public "container-title":string;
  public publisher:string;
  public author:{given:string, family:string, 'parse-names':boolean}[] =[];
  public issued ={};//{"date-parts":string[]}[] =[];
  public date:string;
  public authors:string[] =[];
  public volume:string;
  public page:string ;
  public ISSN:string ;
  public issue:string;


}
